/*
 * MainFrame.cpp - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "decoder/stdafx.h"
#include "MainFrame.h"

#include <Debug.h>
#include <MenuBar.h>
#include "WinView.h"
#include "MouseUpFilter.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace App;
#endif

/************************************************************
	construction
************************************************************/
CMainFrame::CMainFrame(	BRect frame, const char *title,
						window_type type, uint32 flags,
						uint32 workspace)
: BWindow(frame, title, type, flags, workspace)
{
	AddCommonFilter( (BMessageFilter *)new CMouseUpFilter() );
	m_lpMenuBar = NULL;
}

/************************************************************
	init mainview	
************************************************************/
void CMainFrame::InitView( BView *_lpMainView )
{
	ASSERT( _lpMainView );
	
	BRect WinBounds = Bounds();
	//
	_lpMainView->ResizeTo( WinBounds.Width(), WinBounds.Height() );
	//
	AddChild( _lpMainView );

	return ;
}

/************************************************************
	init mainview	
************************************************************/
void CMainFrame::InitView( 	BView *_lpMainView,
							BMenuBar *_lpMenuBar )
{
	ASSERT( _lpMainView );
	
	BRect WinBounds = Bounds();
	
	AddChild( _lpMenuBar );
	BRect MenuBounds = _lpMenuBar->Bounds();
	
	//
	ResizeTo( WinBounds.Width(), WinBounds.Height() + MenuBounds.Height() );
	// ビューの調節
//	_lpMainView->ResizeTo(	WinBounds.Width(),
//							WinBounds.Height() - MenuBounds.Height() - 1 );
	_lpMainView->ResizeTo( WinBounds.Width(), WinBounds.Height() );
	_lpMainView->MoveBy( 0, MenuBounds.Height() + 1);
	//
	AddChild( _lpMainView );
	
	return ;
}


/************************************************************
	Quit this
************************************************************/
void CMainFrame::Quit(void)
{
	// exit thread
	if( m_lpSD ){
		m_lpSD->m_bExit = true;
	}
	status_t status;
	::wait_for_thread( m_ThreadID, &status );
		
	// Quit Application
	be_app->PostMessage( B_QUIT_REQUESTED );
	
	// Quit this Window
	BWindow::Quit();
}

/***************************************************************
	ClientRect->WindowRect
***************************************************************/
void CMainFrame::AdjustWindow( BRect *_lpRect )
{
	if( m_lpMenuBar ){
		BRect MenuBounds = m_lpMenuBar->Bounds();
		_lpRect->bottom += MenuBounds.Height() + 1;
	}
}

