/*
 * MainFrame.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __MainFrame_h__
#define __MainFrame_h__
/****************************************************************
	main frame
****************************************************************/
#include <Window.h>
#include "WinApp.h"

#include "decoder/ScenarioDecoderSystem.h"
#include "decoder/ScenarioDecoder.h"

//
// CMainFrame
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class App::CMainFrame : public BWindow {
#else
class CMainFrame : public BWindow {
#endif
public:
	// construction
	CMainFrame(	BRect frame,
				const char *title,
				window_type type,
				uint32 flags,
				uint32 workspace = B_CURRENT_WORKSPACE );
	virtual ~CMainFrame(){};
	//
	void InitView( BView *_lpMainView );
	void InitView( BView *_lpMainView, BMenuBar *_lpMenuBar );
	
	// ClientRect->WindowRect
	void AdjustWindow( BRect *_lpRect );
	
	// Quit
	void Quit(void);

	//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	void SetSD( ALSD::CScenarioDecoder *_lpSD ){m_lpSD = _lpSD;};
#else
	void SetSD( CScenarioDecoder *_lpSD ){m_lpSD = _lpSD;};
#endif
	void SetTID( thread_id _id ){ m_ThreadID = _id;};

protected:
	//
private:
	//
	BMenuBar *m_lpMenuBar;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	ALSD::CScenarioDecoder	*m_lpSD;
#else
	CScenarioDecoder	*m_lpSD;
#endif
	thread_id m_ThreadID;
};

#endif

