/*
 * WinView.cpp - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "decoder/stdafx.h"
#include "WinView.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace App;
#endif
/************************************************************
	construction
*************************************************************/
CWinView::CWinView( BRect frame, const char *name, 
					uint32 resizeMask, uint32 flags )
: BView(frame, name, resizeMask, flags)
{
	//
	m_lpView = NULL;
}

CWinView::~CWinView()
{
}

/***********************************************************
	draw
***********************************************************/
void CWinView::Draw(BRect updateRect)
{
	stGrpRect rect;
	rect.left = updateRect.left;
	rect.right= updateRect.right + 1;
	rect.top    = updateRect.top;
	rect.bottom = updateRect.bottom + 1;
	if( m_lpView )m_lpView->OnDraw( &rect );
}

/*************************************************************
	Mouse down handler
*************************************************************/
void CWinView::MouseDown(BPoint where)
{
	MakeFocus();

	uint32 buttons = 0;
	int32  work;
	Window()->CurrentMessage()->FindInt32("buttons", &work);
	buttons = work;
	
	stGrpPoint pt;
	pt.x = where.x;
	pt.y = where.y;
	
	int32 check = buttons;
	switch( buttons ){
		case B_PRIMARY_MOUSE_BUTTON:
			if( m_lpView )m_lpView->OnLButtonDown(&pt);
			break;
		case B_SECONDARY_MOUSE_BUTTON:
			if( m_lpView )m_lpView->OnRButtonDown(&pt);
			break;
	}

	
/*	while( buttons & check ){
		::snooze( 20 * 1000 );
		GetMouse(&where, &buttons, true);
	}
	// mouse up
	pt.x = where.x;
	pt.y = where.y;
	switch( check ){
		case B_PRIMARY_MOUSE_BUTTON:
			if( m_lpView )m_lpView->OnLButtonUp(&pt);
			break;
		case B_SECONDARY_MOUSE_BUTTON:
			if( m_lpView )m_lpView->OnRButtonUp(&pt);
			break;
	}		
*/
}

/********************************************************************
********************************************************************/
void CWinView::MouseUp( BPoint where )
{
	uint32 buttons = 0;
	int32  work;
	Window()->CurrentMessage()->FindInt32("buttons", &work);
	buttons = work;

	stGrpPoint pt;
	pt.x = where.x;
	pt.y = where.y;
	
	// BeOSはどのボタンがupしたかわからない？
	// っていうか、マウスボタンごとに追跡してないのね
	if( m_lpView )m_lpView->OnLButtonUp(&pt);
	if( m_lpView )m_lpView->OnRButtonUp(&pt);
	
/*	switch( buttons ){
		case B_PRIMARY_MOUSE_BUTTON:
			if( m_lpView )m_lpView->OnLButtonUp(&pt);
			break;
		case B_SECONDARY_MOUSE_BUTTON:
			if( m_lpView )m_lpView->OnRButtonUp(&pt);
			break;
	}		
*/		
}


/********************************************************************
	Mouse move handler
********************************************************************/
void CWinView::MouseMoved(BPoint point, uint32 transit, const BMessage *message)
{
	stGrpPoint pt;
	pt.x = point.x;
	pt.y = point.y;
	
	if( m_lpView )m_lpView->OnMouseMove( &pt );
}

/********************************************************************
********************************************************************/
void CWinView::MessageReceived( BMessage *message )
{
	switch( message->what ){
/*		case B_MOUSE_UP:
			{
				uint32 buttons;
				BPoint where;
				GetMouse(&where, &buttons, true);
				MouseUp( where );
			}
			break;
*/		default:
			BView::MessageReceived(message);
			break;
	}
}
