/*
 * AliceCG_PMS256.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __AliceCG_PMS256_h__
#define __AliceCG_PMS256_h__
/**********************************************************************
	scenario decoder system PMS256 format
**********************************************************************/
#include "AliceCG_PMS.h"
//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD_ALCG {
#endif
	class CAliceCG_PMS;
	class CAliceCG_PMS256;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif
//
//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class ALSD_ALCG::CAliceCG_PMS256 : public ALSD_ALCG::CAliceCG_PMS {
#else
class CAliceCG_PMS256 : public CAliceCG_PMS {
#endif
public:
	CAliceCG_PMS256( const unsigned char *_lpMem );
	virtual ~CAliceCG_PMS256();

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	virtual void DrawBitmap( ALSD::COffScreen &_Screen, long _x, long _y,
							 long _PosFlag, stGrpRect *_lpRect,
							 long _Brightness );
#else
	virtual void DrawBitmap( COffScreen &_Screen, long _x, long _y,
							 long _PosFlag, stGrpRect *_lpRect,
							 long _Brightness );
#endif


protected:
private:
};

#endif
