/*
 * AliceCG_PMS64K.cpp - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"

#include "AliceCG_PMS64K.h"
#include "EALSD.h"
#include "OffScreen.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_ALCG;
using namespace ALSD_OFFSCR;
#endif
/**********************************************************************
	RXgNV
**********************************************************************/
CAliceCG_PMS64K::CAliceCG_PMS64K( const unsigned char *_lpMem )
: CAliceCG_PMS( _lpMem )
{
	//
	GetHeader();
	if( m_Header.Bpp != 16 )throw EALSD_Msg( "error:not PMS64K Bpp(%d)\n", m_Header.Bpp );
	if( m_Header.X < 0 || m_Header.Y < 0 ){
		throw EALSD_Msg( "error:PMS64K X(%d)orY(%d)\n", m_Header.X, m_Header.Y );
	}
}

CAliceCG_PMS64K::~CAliceCG_PMS64K()
{
}

