/*
 * CDPlayer.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __CDPlayer_h__
#define __CDPlayer_h__
/**********************************************************************
	scenario decoder system CD-DA interface
**********************************************************************/
#include "ScenarioDecoderSystem.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD{
#endif
	class CCDPlayer;
	
	struct stCDPTrackInfo {
		long track;
		long min;
		long sec;
		long frame;
	};
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

//
// CD-DAĐC^[tF[X
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class ALSD::CCDPlayer {
#else
class CCDPlayer {
#endif
public:
	CCDPlayer(){};
	virtual ~CCDPlayer(){};
	
	// interface
	virtual long Play( long _Track, int _Loop ) = 0; // _Loop == 0 [v
	virtual long GetPlayTrack( stCDPTrackInfo *_lpTrack ) = 0;

};

#endif
