/*
 * CDPlayer_BeOS.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __CDPlayer_BeOS_h__
#define __CDPlayer_BeOS_h__
/**********************************************************************
	scenario decoder system CD-DA for BeOS
**********************************************************************/
#include "CDPlayer.h"
#include <Looper.h>
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD_BeOS {
#endif
	class CCDPlayer_BeOS;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD_CDP_BeOS {
#endif
	enum CDState {
		NoCD,
		Stopped,
		Paused,
		Playing,
		Skipping
	};
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

//
//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class ALSD_BeOS::CCDPlayer_BeOS : public ALSD::CCDPlayer {
#else
class CCDPlayer_BeOS : public CCDPlayer {
#endif
public:
	CCDPlayer_BeOS();
	virtual ~CCDPlayer_BeOS();
	
	// interface
	virtual long Play( long _Track, int _Loop ); // _Loop == 0 [v
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	virtual long GetPlayTrack( ALSD::stCDPTrackInfo *_lpTrack );
#else
	virtual long GetPlayTrack( stCDPTrackInfo *_lpTrack );
#endif

	long GetNowTrack( void )const { return m_NowTrack;};
	long GetNowLoop ( void )const { return m_NowLoop;};
	void SetNowLoop ( long _loop ){ m_NowLoop = _loop;};

protected:
	//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	ALSD_CDP_BeOS::CDState GetState( void );
#else
	CDState GetState( void );
#endif
	static int32 PlayFunc(void *_lpVoid);

	//
	int			 m_Devicefd;
	long		 m_NowTrack;
	long		 m_NowLoop;
	bool		 m_bEnd;

private:
};

#endif
