/*
 * CDPlayer_WIN32.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __CDPlayer_WIN32_h__
#define __CDPlayer_WIN32_h__
/**********************************************************************
	scenario decoder system CD-DA for WIN32
**********************************************************************/
#include "CDPlayer.h"

#define STRICT 1
#include <windows.h>

namespace ALSD_WIN32 {
	class CCDPlayer_WIN32;
};

//
//
class ALSD_WIN32::CCDPlayer_WIN32 : public ALSD::CCDPlayer {
public:
	CCDPlayer_WIN32();
	virtual ~CCDPlayer_WIN32();
	
	// interface
	virtual long Play( long _Track, int _Loop ); // _Loop == 0 [v
	virtual long GetPlayTrack( ALSD::stCDPTrackInfo *_lpTrack );

	bool IsDestroy( void )const {return m_bEnd;};
//	unsigned short GetDeviceID( void )const { return m_DeviceID;};
	long GetNowTrack( void )const { return m_NowTrack;};
	long GetNowLoop ( void )const { return m_NowLoop;};
	void SetNowLoop ( long _loop ){ m_NowLoop = _loop;};

	void PlayTrack( unsigned short _DeviceID, long _Track );
	void StopTrack( unsigned short _DeviceID );

protected:
	static unsigned long __stdcall PlayFunc( void *_lpVoid );

	DWORD			 m_ThreadID;
	HANDLE			 m_hThread;
//	unsigned short	 m_DeviceID;
	long			 m_NowTrack;
	long			 m_NowLoop;
	bool			 m_bEnd;
//	long			 m_LastTrack;
private:
};

#endif
