/*
 * CommandDriver.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __CommandDriver_h__
#define __CommandDriver_h__
/**********************************************************************
	scenario decorder command driver
	
**********************************************************************/
#include "ScenarioDecoderSystem.h"

#include "EALSD.h"
//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD {
#endif
	class CCommandDriver;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
}
#endif
//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD_CMDDRV {
#endif
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	typedef void ( ALSD::CCommandDriver::*LPCOMMAND1ST )(void);
#else
	typedef void ( CCommandDriver::*LPCOMMAND1ST )(void);
#endif
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif
//
// class
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class ALSD::CCommandDriver {
#else
class CCommandDriver {
#endif
public:
	CCommandDriver( CScenarioDecoder *_lpScenarioDecoder );
	virtual ~CCommandDriver();
	
	// init
	void Initialize(void);	// hCo擾\ɂȂĂ

	// command
	long ExecCommandA2Z( long Cmd );
	// Command F
	void SetDataTableAddress( long _Adr ){ m_DataTableAddress = _Adr;};
	// 
	long CommandIK0_Sub( void );
	long CommandIK6_Sub( void );

protected:
	//
	CScenarioDecoder	*m_lpSD;
	CGraphicDriver		*m_lpGD;
	CExpressionDriver	*m_lpED;
	
	// CommandG(PC)
	long	m_GPC;	// OtBbNWJtO0,1...7
	// CommandF
	long	 m_DataTableAddress;

	// CommandS
	long	 m_Loop;	// CD-DÃ[v

	// EC/ESʃNAǗ
	stGrpRect		m_rcClear[100];
	unsigned char	m_ClearPalette[100];

	// ^C}Ǘs
	unsigned long m_NowTime;	// ^C}NAl
	unsigned long m_OffsetTime; // ^C}NAƂ̎
	//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	ALSD_CMDDRV::LPCOMMAND1ST	m_lpCmdFuncTbl[26];
	ALSD_CMDDRV::LPCOMMAND1ST	m_lpCmdFuncTblC[26];
	ALSD_CMDDRV::LPCOMMAND1ST	m_lpCmdFuncTblI[26];
#else
	LPCOMMAND1ST	m_lpCmdFuncTbl[26];
	LPCOMMAND1ST	m_lpCmdFuncTblC[26];
	LPCOMMAND1ST	m_lpCmdFuncTblI[26];
#endif
	
	//
	long Repeat;

	// 1st pass
	void _CommandA( void );
	void _CommandB( void );
	void _CommandC( void );
	void _CommandD( void );
	void _CommandE( void );
	void _CommandF( void );
	void _CommandG( void );
	void _CommandH( void );
	void _CommandI( void );
	void _CommandJ( void );
	void _CommandK( void );
	void _CommandL( void );
	void _CommandM( void );
	void _CommandN( void );
	void _CommandO( void );
	void _CommandP( void );
	void _CommandQ( void );
	void _CommandR( void );
	void _CommandS( void );
	void _CommandT( void );
	void _CommandU( void );
	void _CommandV( void );
	void _CommandW( void );
	void _CommandX( void );
	void _CommandY( void );
	void _CommandZ( void );

	/////////////////////////////////////////////////////////
	// 2ndpass
	void CommandB0( void );
	void CommandB1( void );
	void CommandB2( void );
	void CommandB3( void );
	void CommandB4( void );
	void CommandB10( void );
	void CommandB11( void );
	void CommandB21( void );
	void CommandB22( void );
	void CommandB23( void );
	void CommandB24( void );
	void CommandB31( void );
	void CommandB32( void );
	void CommandB33( void );
	void CommandB34( void );
	
	void CommandCB( void );
	void CommandCC( void );
	void CommandCD( void );
	void CommandCE( void );
	void CommandCF( void );
	void CommandCK( void );
	void CommandCL( void );
	void CommandCM( void );
	void CommandCP( void );
	void CommandCS( void );
	void CommandCT( void );
	void CommandCU( void );
	void CommandCV( void );
	void CommandCX( void );

	void CommandDC( void );
	void CommandDF( void );
	void CommandDI( void );
	void CommandDR( void );
	void CommandDS( void );

	void CommandEC( void );
	void CommandES( void );

	void CommandF1( void );
	void CommandF2( void );
	void CommandF3( void );
	void CommandF4( void );
	void CommandF5( void );
	void CommandF6( void );
	void CommandF7( void );

	void CommandG0( void );
	void CommandG1( void );
	void CommandGS( void );
	void CommandGX( void );

	void CommandIA( void );
	void CommandIC( void );
	void CommandIG( void );
	void CommandIK( void );
	void CommandIM( void );
	void CommandIX( void );
	void CommandIY( void );
	void CommandIZ( void );
	
	void CommandJ0( void );
	void CommandJ1( void );
	void CommandJ2( void );
	void CommandJ3( void );
	void CommandJ4( void );

	// for system3.6
	void CommandKI( void );
	void CommandKK( void );
	void CommandKN( void );
	void CommandKP( void );
	void CommandKQ( void );
	void CommandKR( void );
	void CommandKW( void );
	
	void CommandLC( void );
	void CommandLD( void );
	void CommandLE( void );
	void CommandLG( void );
	void CommandLHD( void );
	void CommandLHG( void );
	void CommandLHM( void );
	void CommandLHS( void );
	void CommandLHW( void );
	void CommandLL( void );
	void CommandLM( void );
	void CommandLO( void );
	void CommandLP( void );
	void CommandLT( void );
	void CommandLU( void );
	void CommandLV( void );

	void CommandLXG( void );
	void CommandLXO( void );
	void CommandLXC( void );
	void CommandLXL( void );
	void CommandLXS( void );
	void CommandLXP( void );
	void CommandLXR( void );
	void CommandLXW( void );
	
	void CommandMA( void );
	void CommandMC( void );
	void CommandMD( void );
	void CommandME( void );
	void CommandMF( void );
//	void CommandMG( void );
	void CommandMG0( void );
	void CommandMG1( void );
	void CommandMG2( void );
	void CommandMG3( void );
	void CommandMG4( void );
	void CommandMG5( void );
	void CommandMG6( void );
	void CommandMG7( void );
	void CommandMG100( void );
	void CommandMH( void );
	void CommandMI( void );
	void CommandMJ( void );
	void CommandML( void );
	void CommandMM( void );
	void CommandMN( void );
	void CommandMP( void );
	void CommandMS( void );
	void CommandMT( void );
	void CommandMV( void );
//	void CommandMZ( void );
	void CommandMZ0( void );
//	void CommandMX( void );
	void CommandMXS( void );
	void CommandMXA( void );
	void CommandMXM( void );

	// lZ
	void CommandN_ADD( void );
	void CommandN_SUB( void );
	void CommandN_MUL( void );
	void CommandN_DIV( void );
	
	void CommandN_GT( void );
	void CommandN_LT( void );
	void CommandN_EQ( void );
	void CommandN_NE( void );
	
	void CommandN_AND( void );
	void CommandN_OR( void );
	void CommandN_XOR( void );
	void CommandN_NOT( void );

	void CommandNB( void );
	void CommandNC( void );
	void CommandNI( void );
	void CommandNP( void );
	void CommandNR( void );
	void CommandNO( void );
	void CommandNT( void );
	// {x
//	void CommandND( void );
	void CommandND_ADD( void );
	void CommandND_SUB( void );
	void CommandND_MUL( void );
	void CommandND_DIV( void );
	void CommandNDA( void );
	void CommandNDC( void );
	void CommandNDD( void );
	void CommandNDH( void );
	void CommandNDM( void );
	
	void CommandPC( void );
	void CommandPD( void );
	void CommandPF( void );
	void CommandPG( void );
	void CommandPN( void );
	void CommandPP( void );
	void CommandPS( void );
	void CommandPT0( void );
	void CommandPT1( void );
	void CommandPW( void );

	void CommandQB( void );
	void CommandQC( void );
	void CommandQD( void );
	void CommandQE( void );
	void CommandQG( void );
	void CommandQL( void );
	void CommandQM( void );
	void CommandQP( void );
	void CommandQT( void );
	void CommandQV( void );

	void CommandSC( void );
	void CommandSD( void );
	void CommandSF( void );
	void CommandSG( void );
	void CommandSL( void );
	void CommandSM( void );
	void CommandSO( void );
	void CommandSP( void );
	void CommandSQ( void );
	void CommandSR( void );
	void CommandSV( void );
	//????
	void CommandSI( void );
	
	void CommandSS( void );
	void CommandST( void );
	void CommandSU( void );
	void CommandSW( void );
	// system3.6 compatible
	void CommandSX( void );

	void CommandUC( void );
	void CommandUD( void );
	void CommandUG( void );
	void CommandUP0( void );
	void CommandUP1( void );
	void CommandUP3( void );
	void CommandUR( void );
	void CommandUS( void );

	void CommandVA( void );
	void CommandVB( void );
	void CommandVC( void );
	void CommandVE( void );
	void CommandVF( void );
	void CommandVG( void );
	void CommandVH( void );
	void CommandVIC( void );
	void CommandVIP( void );
	void CommandVJ( void );
	void CommandVP( void );
	void CommandVR( void );
	void CommandVS( void );
	void CommandVT( void );
	void CommandVV( void );
	void CommandVW( void );
	void CommandVX( void );
	void CommandVZ( void );
	
	void CommandWV( void );
	void CommandWW( void );
	void CommandWX( void );
	void CommandWZ0( void );
	
	void CommandZA( void );
	void CommandZB( void );
	void CommandZC( void );
	void CommandZD( void );
	void CommandZE( void );
	void CommandZF( void );
	void CommandZG( void );
	void CommandZH( void );
	void CommandZI( void );
	void CommandZK( void );
	void CommandZL( void );
	void CommandZM( void );
	void CommandZS( void );
	void CommandZR( void );
	void CommandZW( void );
	void CommandZT( void );
	void CommandZZ( void );

	void CommandZT0( void );
	void CommandZT1( void );
	void CommandZT2( void );
	void CommandZT3( void );
	void CommandZT4( void );
	void CommandZT5( void );
	void CommandZT10( void );
	void CommandZT11( void );

	void CommandZZ0( void );
	void CommandZZ1( void );
	void CommandZZ2( void );
	void CommandZZ3( void );
	void CommandZZ4( void );
	void CommandZZ5( void );
	void CommandZZ6( void );
	void CommandZZ7( void );
	void CommandZZ8( void );
	void CommandZZ9( void );
	void CommandZZ10( void );
	void CommandZZ11( void );
	void CommandZZ12( void );
	void CommandZZ13( void );
};

#endif
