/*
 * CommandDriverD.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	D command
**********************************************************************/
void CCommandDriver::_CommandD(void)
{
	switch( m_lpSD->GetParser()->GetC() ){
		case 'C':
			CommandDC(); break;
		case 'F':
			CommandDF(); break;
		case 'I':
			CommandDI(); break;
		case 'R':
			CommandDR(); break;
		case 'S':
			CommandDS(); break;
		default:
			throw EALSD_Msg( "error: D? unknown command\n" );
			break;
	}
}

/**********************************************************************
	zobt@̊m
**********************************************************************/
void CCommandDriver::CommandDC( void )
{
	long page = m_lpED->GetExpValue();
	long size = m_lpED->GetExpValue();
	long save = m_lpED->GetExpValue();

	m_lpED->AllocateArray( page, size, save );

	TRACE( "command:DC(...)\n" );	
}
/**********************************************************************
	z̃NA
**********************************************************************/
void CCommandDriver::CommandDF( void )
{
	long *data_var = m_lpED->GetVariableNo();
	long count = m_lpED->GetExpValue();
	long data  = m_lpED->GetExpValue();

	for( long i = 0;i < count; i++){
		data_var[i] = data;
	}
	TRACE( "command:DF(...)\n" );	
}
/**********************************************************************
	z̈̏擾
**********************************************************************/
void CCommandDriver::CommandDI( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:DI(...)\n" );	
}
/**********************************************************************
	z̉
**********************************************************************/
void CCommandDriver::CommandDR( void )
{
	long *data_var = m_lpED->GetVariableNo();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:DR(...)\n" );	
}
/**********************************************************************
	zւ̐ݒ
**********************************************************************/
void CCommandDriver::CommandDS( void )
{
	long *point_var = m_lpED->GetVariableNo();
	long *data_var  = m_lpED->GetVariableNo();
	long  var_no	= m_lpED->GetPrevVarNo();
	long  offset	= m_lpED->GetExpValue();
	long  page		= m_lpED->GetExpValue();

	m_lpED->DefineArray( point_var, var_no, offset, page );
	TRACE( "command:DS(...)\n" );	
}

