/*
 * CommandDriverE.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	E command
**********************************************************************/
void CCommandDriver::_CommandE(void)
{
	switch( m_lpSD->GetParser()->GetC() ){
		case 'C':
			CommandEC(); break;
		case 'S':
			CommandES(); break;
		default:
			throw EALSD_Msg( "error: E? unknown command\n" );
			break;
	}
}

/**********************************************************************
	ʃNA
**********************************************************************/
void CCommandDriver::CommandEC( void )
{
	long num = m_lpED->GetExpValue() - 1;

	if( num < 0 ){
		// NCAg̈NA
		stGrpRect rect;
		m_lpGD->GetViewRect( &rect );
		m_lpGD->FillRect( rect.left, rect.top,
						  rect.right - rect.left,
						  rect.bottom- rect.top, 0 );
		m_lpGD->OnDraw( &rect );
	}else{
		m_lpGD->FillRect( m_rcClear[num].left, m_rcClear[num].top,
						  m_rcClear[num].right - m_rcClear[num].left,
						  m_rcClear[num].bottom- m_rcClear[num].top,
						  m_ClearPalette[num] );
		m_lpGD->OnDraw( &m_rcClear[num] );
	}

	TRACE( "command:EC( ... )\n" );
}
/**********************************************************************
	ʃNA֌Wo^
**********************************************************************/
void CCommandDriver::CommandES( void )
{
	long num= m_lpED->GetExpValue() - 1;
	long c	= m_lpED->GetExpValue();
	long x1	= m_lpED->GetExpValue();
	long y1 = m_lpED->GetExpValue();
	long x2 = m_lpED->GetExpValue();
	long y2 = m_lpED->GetExpValue();
	
	m_ClearPalette[num] = c;
	m_rcClear[num].left	= x1;
	m_rcClear[num].top	= y1;
	m_rcClear[num].right= x1 + x2;
	m_rcClear[num].bottom=y1 + y2;
	
	TRACE( "command:ES( ... )\n" );
}
