/*
 * CommandDriverI.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"
#include "MessageCtrl.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace{
#endif
	long GetIKCode( unsigned long _key );
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	L[R[hϊIK
**********************************************************************/
long GetIKCode( unsigned long _key )
{
	long ret = 0;
	switch( _key ){
		case  56: // W
		case 104: // W
		case  38: // 
			ret = 1;
			break;
		case  50: // Q
		case  98: // Q
		case  40: // 
			ret = 2;
			break;
		case  52: // S
		case 100: // S
		case  37: // 
			ret = 4;
			break;
		case  54: // U
		case 102: // U
		case  39: // 
			ret = 8;
			break;
		case 13: // enter
			ret = 16;
			break;
		case 32: // space
			ret = 32;
			break;
		case 27: // ESC
			ret = 64;
			break;
		case  9: // TAB
			ret = 128;
			break;
	}
	if( ret ){
		return ret;
	}
	return ret;
}

/**********************************************************************
	I command
**********************************************************************/
void CCommandDriver::_CommandI(void)
{
#if 1
	long Cmd = m_lpSD->GetParser()->GetC();
	(this->*m_lpCmdFuncTblI[Cmd-'A'])();

#else
	switch( m_lpSD->GetParser()->GetC() ){
		case 'A':
			CommandIA(); break;
		case 'C':
			CommandIC(); break;
		case 'G':
			CommandIG(); break;
		case 'K':
			CommandIK(); break;
		case 'M':
			CommandIM(); break;
		case 'X':
			CommandIX(); break;
		case 'Y':
			CommandIY(); break;
		case 'Z':
			CommandIZ(); break;
		default:
			throw EALSD_Msg( "error: I? unknown command\n" );
			break;
	}
#endif
}

void CCommandDriver::CommandIA( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:IA( ... )\n" );
}
/**********************************************************************
	}EXJ[\̌`ύX
**********************************************************************/
void CCommandDriver::CommandIC( void )
{
	long cursol_num = m_lpED->GetExpValue() - 1;
	long *old_var	= m_lpED->GetVariableNo();

	*old_var = 1;

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:IC( ... )\n" );
}
/**********************************************************************
	L[͏Ԏ擾
**********************************************************************/
void CCommandDriver::CommandIG( void )
{
	long *var = m_lpED->GetVariableNo();
	long code = m_lpED->GetExpValue();
	long num  = m_lpED->GetExpValue();
	long reverse=m_lpED->GetExpValue();

	*var = 0;

//	if( m_lpGD->IsLButtonDown(NULL) && code >= 1 && 1 < code + num )*var = 1;
//	if( m_lpGD->IsRButtonDown(NULL) && code >= 2 && 2 < code + num )*var = 1;

	long key = 0;
	for( long i = 0; i < 5 && key == 0; i++ ){
		key = m_lpGD->GetKeyCode();
	}

	if( key >= code && key < code + num ){
		var[key-code] = 1;
	}

	TRACE( "error:[Half] implement... /" );
	TRACE( "command:IG( ... )\n" );
}
/**********************************************************************
	L[{[h擾
**********************************************************************/
void CCommandDriver::CommandIK( void )
{
	long num = m_lpSD->GetParser()->GetC();
	long rnd = 0;
	unsigned long key;
	static long prevrnd;

	switch( num ){
		case 0:	// L[͑҂(ʏ탊s[g)
		case 1:	// L[͑҂(s[g)
			while( !(rnd = CommandIK0_Sub()) );
			break;
		case 2:	// lntrdNbN̂ݎ擾
			if( m_lpGD->IsLButtonDown( NULL ) )rnd |= 16;
			if( m_lpGD->IsRButtonDown( NULL ) )rnd |= 32;
			break;
		case 3:	// L[{[h̎擾
			for( int i = 0; i < 8; i++ ){
				key = m_lpGD->GetKeyCode();
				if( key )break;
				m_lpGD->Sleep( 50 );
			}
			if( rnd == 0 && key == 0 )Repeat = 0;
			switch( Repeat ){
				case 0:
					if( key )Repeat++;
					break;
				case 1:
					Repeat++;
					m_lpGD->Sleep( 300 );break;
				case 2:
					m_lpGD->Sleep( 50 );break;
			}
			rnd |= ::GetIKCode( key );
			break;
		case 4:	// JOY-PAD
			break;
		case 6:	// ̏uԂ̃L[Ԃ
			rnd = CommandIK6_Sub();
			break;
	}

	*m_lpED->GetSystemVar() = rnd;
	TRACE( "command:IK( ... )\n" );
}

/**********************************************************************
**********************************************************************/
long CCommandDriver::CommandIK0_Sub( void )
{
	long rnd = 0;
	unsigned long key = 0;

	key = m_lpGD->GetKeyCode();

	if( m_lpGD->IsLButtonDown( NULL ) ){
		rnd |= 16;
	}
	if( m_lpGD->IsRButtonDown( NULL ) ){
		rnd |= 32;
	}
	if( rnd == 0 && key == 0 )Repeat = 0;
	rnd |= ::GetIKCode( key );
	switch( Repeat ){
		case 0:
			if( rnd ){
				Repeat++;
				m_lpGD->Sleep( 300 );break;
			}
			break;
		case 1:
			Repeat++;
			m_lpGD->Sleep( 300 );break;
		case 2:
			m_lpGD->Sleep( 100 );break;
	}

	if( Repeat > 1){
		long prernd = rnd;
		rnd = 0;
		key = m_lpGD->GetKeyCode();
	
		if( m_lpGD->IsLButtonDown( NULL ) ){
			rnd |= 16;
		}
		if( m_lpGD->IsRButtonDown( NULL ) ){
			rnd |= 32;
		}
		rnd |= ::GetIKCode( key );
		if( rnd != prernd )Repeat = 0;
	}

	return rnd;
}

/**********************************************************************
**********************************************************************/
long CCommandDriver::CommandIK6_Sub( void )
{
	long rnd = 0;
	unsigned long key = 0;

	key = m_lpGD->GetKeyCode();

	if( m_lpGD->IsLButtonDown( NULL ) ){
		rnd |= 16;
	}
	if( m_lpGD->IsRButtonDown( NULL ) ){
		rnd |= 32;
	}
	if( rnd == 0 && key == 0 )Repeat = 0;
	rnd |= ::GetIKCode( key );

	return rnd;
}

/**********************************************************************
	}EX擾
**********************************************************************/
void CCommandDriver::CommandIM( void )
{
	long *cursol_x = m_lpED->GetVariableNo();
	long *cursol_y = m_lpED->GetVariableNo();

	*m_lpED->GetSystemVar() = 0;
	stGrpPoint pt;
	if( m_lpGD->IsLButtonDown( &pt ) ){
		*m_lpED->GetSystemVar() = 16;
	}
	if( m_lpGD->IsRButtonDown( &pt ) ){
		*m_lpED->GetSystemVar() = 32;
	}
	*cursol_x = pt.x;
	*cursol_y = pt.y;

	TRACE( "command:IM( ... )\n" );
}
/**********************************************************************
	̑I܂ŐiޏԎ擾
**********************************************************************/
void CCommandDriver::CommandIX( void )
{
	long *var = m_lpED->GetVariableNo();

	if( m_lpSD->GetMsgCtrl()->GetAutoNextPage() ){
		*var = 1;
	}else{
		*var = 0;
	}

	TRACE( "command:IX( ... )\n" );
}
/**********************************************************************
	̑I܂Őiނ̃tOݒ
**********************************************************************/
void CCommandDriver::CommandIY( void )
{
	long no = m_lpED->GetExpValue();

	switch( no ){
		case 0: // 
			m_lpSD->GetMsgCtrl()->SetAutoNextPage( false );
			break;
		case 2: // I or }EXNbNŉiftHgj
			break;
		case 3: // I or }EXNbNŉȂ
			break;
	}

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:IY( ... )\n" );
}
/**********************************************************************
	}EXJ[\̈ʒuύX
**********************************************************************/
void CCommandDriver::CommandIZ( void )
{
	long start_x = m_lpED->GetExpValue();
	long start_y = m_lpED->GetExpValue();

	m_lpGD->SetMousePos( start_x, start_y );

	TRACE( "command:IZ( ... )\n" );
}

