/*
 * CommandDriverP.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	P command
**********************************************************************/
void CCommandDriver::_CommandP(void)
{
	long Cmd = m_lpSD->GetParser()->GetC();
	switch( Cmd ){
		case 'C':
			CommandPC(); break;
		case 'D':
			CommandPD(); break;
		case 'F':
			CommandPF(); break;
		case 'G':
			CommandPG(); break;
		case 'N':
			CommandPN(); break;
		case 'P':
			CommandPP(); break;
		case 'S':
			CommandPS(); break;
		case 'T':
			switch( m_lpSD->GetParser()->GetC() ){
				case 0:
					CommandPT0(); break;
				case 1:
					CommandPT1(); break;
				default:
					throw EALSD_Msg( "error: PT? unknown command\n" );
			}
			break;
		case 'W':
			CommandPW(); break;
		default:
			throw EALSD_Msg( "error: P? unknown command\n" );
	}
}
/**********************************************************************
	pbgRg[̐ݒ
**********************************************************************/
void CCommandDriver::CommandPC( void )
{
	long num = m_lpED->GetExpValue();

	m_lpSD->GetGrpDriver()->SetPaletteCtrl(num);

	TRACE( "command:PC( ... )\n" );
}
/**********************************************************************
	bfWJ̖xw肷
**********************************************************************/
void CCommandDriver::CommandPD( void )
{
	long num = m_lpED->GetExpValue();

	m_lpGD->SetCGLoadBrightness( num );
	TRACE( "error:[Half] implement... /" );
	TRACE( "command:PD( ... )\n" );
}
/**********************************************************************
	OtBbNGtFNgi
**********************************************************************/
void CCommandDriver::CommandPF( void )
{
	long no = m_lpSD->GetParser()->GetC();
	long num, wait_flag;

	switch( no ){
		case 0: // tF[hC(ʏ)
			num = m_lpED->GetExpValue();
			wait_flag = 0;
			m_lpGD->FadeInView( num, wait_flag );
			break;
		case 1: // tF[hAEg
			num = m_lpED->GetExpValue();
			wait_flag = 0;
			m_lpGD->FadeOutView( num, wait_flag );
			break;
		case 2: // tF[hC
			num = m_lpED->GetExpValue();
			wait_flag = m_lpED->GetExpValue();
			m_lpGD->FadeInView( num, wait_flag );
			break;
		case 3: // tF[hAEg
			num = m_lpED->GetExpValue();
			wait_flag = m_lpED->GetExpValue();
			m_lpGD->FadeOutView( num, wait_flag );
			break;
	}
	TRACE( "command:PF( ... )\n" );
}
/**********************************************************************
	pbgf[^ϐɎ擾
**********************************************************************/
void CCommandDriver::CommandPG( void )
{
	long *var = m_lpED->GetVariableNo();
	long num1 = m_lpED->GetExpValue();
	long num2 = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:PG( ... )\n" );
}
/**********************************************************************
	numԂ̂bf\鎞AJ[pbgWJȂ悤ɂ
**********************************************************************/
void CCommandDriver::CommandPN( void )
{
	long num = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:PN( ... )\n" );
}
/**********************************************************************
**********************************************************************/
void CCommandDriver::CommandPP( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:PP( ... )\n" );
}
/**********************************************************************
	J[pbg̐ݒ
**********************************************************************/
void CCommandDriver::CommandPS( void )
{
	long plane	= m_lpED->GetExpValue();
	long red	= m_lpED->GetExpValue();
	long green	= m_lpED->GetExpValue();
	long blue	= m_lpED->GetExpValue();

	m_lpGD->SetPalette( plane, red, green, blue );
	TRACE( "command:PS( %d, %d, %d, %d )\n", plane, red, green, blue );
}
/**********************************************************************
**********************************************************************/
void CCommandDriver::CommandPT0( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:PT0( ... )\n" );
}
/**********************************************************************
**********************************************************************/
void CCommandDriver::CommandPT1( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:PT1( ... )\n" );
}
/**********************************************************************
	zCgtF[h
**********************************************************************/
void CCommandDriver::CommandPW( void )
{
	long no = m_lpSD->GetParser()->GetC();
	long num, wait_flag;

	switch( no ){
		case 0: // 
			num = m_lpED->GetExpValue();
			wait_flag = 0;
			m_lpGD->WhiteInView( num, wait_flag );
			break;
		case 1: // 
			num = m_lpED->GetExpValue();
			wait_flag = 0;
			m_lpGD->WhiteOutView( num, wait_flag );
			break;
		case 2: // 
			num = m_lpED->GetExpValue();
			wait_flag = m_lpED->GetExpValue();
			m_lpGD->WhiteInView( num, wait_flag );
			break;
		case 3: // 
			num = m_lpED->GetExpValue();
			wait_flag = m_lpED->GetExpValue();
			m_lpGD->WhiteOutView( num, wait_flag );
			break;
	}

	TRACE( "command:PW( ... )\n" );
}

