/*
 * CommandDriverQ.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"
#include "FileCtrl.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	Q command
**********************************************************************/
void CCommandDriver::_CommandQ(void)
{
	switch( m_lpSD->GetParser()->GetC() ){
		case 'B':
			CommandQB(); break;
		case 'C':
			CommandQC(); break;
		case 'D':
			CommandQD(); break;
		case 'E':
			CommandQE(); break;
		case 'G':
			CommandQG(); break;
		case 'L':
			CommandQL(); break;
		case 'M':
			CommandQM(); break;
		case 'P':
			CommandQP(); break;
		case 'T':
			CommandQT(); break;
		case 'V':
			CommandQV(); break;
		default:
			throw EALSD_Msg( "error: Q? unknown command\n" );
	}
}

void CCommandDriver::CommandQB( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:QB( ... )\n" );
}
/**********************************************************************
	Z[uf[^̃Rs[
**********************************************************************/
void CCommandDriver::CommandQC( void )
{
	long dst = m_lpED->GetExpValue() - 1;
	long src = m_lpED->GetExpValue() - 1;

	*m_lpED->GetSystemVar() = 
		m_lpSD->GetFileCtrl()->CopyData( dst, src );

	TRACE( "command:QC( ... )\n" );
}
/**********************************************************************
	ϐ̈Ȃǂ̃f[^Z[uiSZ[uj
**********************************************************************/
void CCommandDriver::CommandQD( void )
{
	long num = m_lpED->GetExpValue() - 1;

	*m_lpED->GetSystemVar() = 
		m_lpSD->GetFileCtrl()->SaveDataAll( num );

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:QD( ... )\n" );
}
/**********************************************************************
	ϐ̒lt@Cɏ
**********************************************************************/
void CCommandDriver::CommandQE( void )
{
	string FileName;
	long type = m_lpSD->GetParser()->GetC();
	m_lpSD->GetParser()->GetString( FileName, ':' );
	
	if( type == 0 ){
		long*start_var = m_lpED->GetVariableNo();
		long write_num = m_lpED->GetExpValue();
		*m_lpED->GetSystemVar() = 
			m_lpSD->GetFileCtrl()->SaveData( FileName, start_var, write_num );
	}else{
		long start_var = m_lpED->GetExpValue() - 1;
		long write_num = m_lpED->GetExpValue();
		*m_lpED->GetSystemVar() = 
			m_lpSD->GetFileCtrl()->SaveDataString( FileName, start_var, write_num );
	}

	TRACE( "command:QE( ... )\n" );
}
void CCommandDriver::CommandQG( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:QG( ... )\n" );
}
void CCommandDriver::CommandQL( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:QL( ... )\n" );
}
void CCommandDriver::CommandQM( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:QM( ... )\n" );
}
/**********************************************************************
       ϐ̈Ȃǂ̃f[^ꕔZ[uB(lϐ)
**********************************************************************/
void CCommandDriver::CommandQP( void )
{
	long num	= m_lpED->GetExpValue() - 1;
	long*var	= m_lpED->GetVariableNo();
	long page   = m_lpED->GetPrevVarPage();
	long index  = m_lpED->GetPrevVarIndex();
	long count	= m_lpED->GetExpValue();
	
	*m_lpED->GetSystemVar() = 
		m_lpSD->GetFileCtrl()->SaveDataPart( num, page, index, count );
	TRACE( "command:QP( ... )\n" );
}
void CCommandDriver::CommandQT( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:QT( ... )\n" );
}
void CCommandDriver::CommandQV( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:QV( ... )\n" );
}

