/*
 * CommandDriverS.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"
#include "CDPlayer.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	S command
**********************************************************************/
void CCommandDriver::_CommandS(void)
{
	switch( m_lpSD->GetParser()->GetC() ){
		case 'C':
			CommandSC(); break;
		case 'D':
			CommandSD(); break;
		case 'F':
			CommandSF(); break;
		case 'G':
			CommandSG(); break;
		case 'I':
			CommandSI(); break;
		case 'L':
			CommandSL(); break;
		case 'M':
			CommandSM(); break;
		case 'O':
			CommandSO(); break;
		case 'P':
			CommandSP(); break;
		case 'Q':
			CommandSQ(); break;
		case 'R':
			CommandSR(); break;
		case 'S':
			CommandSS(); break;
		case 'T':
			CommandST(); break;
		case 'U':
			CommandSU(); break;
		case 'V':
			CommandSV(); break;
		case 'W':
			CommandSW(); break;
		case 'X':
			CommandSX(); break;
		default:
			throw EALSD_Msg( "error: S? unknown command\n" );
	}
}

/**********************************************************************
	bc̍Đʒu擾
**********************************************************************/
void CCommandDriver::CommandSC( void )
{
	long *var = m_lpED->GetVariableNo();

	var[0] = 999;
	var[1] = 999;
	var[2] = 999;
	var[3] = 999;

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SC( ... )\n" );
}
/**********************************************************************
	ytJn
**********************************************************************/
void CCommandDriver::CommandSD( void )
{
	long num1 = m_lpED->GetExpValue();
	long num2 = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SD( ... )\n" );
}
/**********************************************************************
	ytF[hC^AEg
**********************************************************************/
void CCommandDriver::CommandSF( void )
{
	long no  = m_lpSD->GetParser()->GetC();
	long num = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SF( ... )\n" );
}
/**********************************************************************
	MIDIݒ
**********************************************************************/
void CCommandDriver::CommandSG( void )
{
	long no = m_lpSD->GetParser()->GetC();
	long arg2=m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SG( ... )\n" );
}
/**********************************************************************
	bctȂ̃[v񐔂w肷
**********************************************************************/
void CCommandDriver::CommandSL( void )
{
	long num = m_lpED->GetExpValue();

	TRACE( "error:No implement... /" );
	TRACE( "command:SS( ... )\n" );
}
/**********************************************************************
	oblf[^ɏ悹
**********************************************************************/
void CCommandDriver::CommandSM( void )
{
	long no = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SM( ... )\n" );
}
/**********************************************************************
	oblfoCX̃T|[g擾
**********************************************************************/
void CCommandDriver::CommandSO( void )
{
	long *var = m_lpED->GetVariableNo();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SO( ... )\n" );
}
/**********************************************************************
	oblĐ
**********************************************************************/
void CCommandDriver::CommandSP( void )
{
	long no = m_lpED->GetExpValue();
	long loop=m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SP( ... )\n" );
}
/**********************************************************************
	EʁX̂oblf[^ĉt
**********************************************************************/
void CCommandDriver::CommandSQ( void )
{
	long noL = m_lpED->GetExpValue();
	long noR = m_lpED->GetExpValue();
	long loop= m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SQ( ... )\n" );
}
/**********************************************************************
	bc^lhchĐ擾
**********************************************************************/
void CCommandDriver::CommandSR( void )
{
	long no   = m_lpSD->GetParser()->GetC();
	long *var = m_lpED->GetVariableNo();

	switch( no ){
		case 0: // CD
			*var = 0;
			break;
		case 1: // MIDI
			*var = 0;
			break;
	}

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SR( ... )\n" );
}
/**********************************************************************
	obl̉ʂ̐ݒ^擾
**********************************************************************/
void CCommandDriver::CommandSV( void )
{
	long flag = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SV( ... )\n" );
}
/**********************************************************************
	w肵̐ڑԂ擾 0:gps
**********************************************************************/
void CCommandDriver::CommandSI( void )
{
	long no   = m_lpSD->GetParser()->GetC();
	long *var = m_lpED->GetVariableNo();

	switch( no ){
		case 0: // MIDI
			*var = 0;
			break;
		case 1: // PCM
			*var = 0;
			break;
		case 2: // CD-DA
			*var = 0;
			break;
	}
	
	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SI( ... )\n" );
}
/**********************************************************************
	ytJnibcj
**********************************************************************/
void CCommandDriver::CommandSS( void )
{
	long num = m_lpED->GetExpValue();

	if( num ){
		m_lpSD->GetCDPlayer()->Play( num + 1, m_Loop );
	}else{
		m_lpSD->GetCDPlayer()->Play( 0, m_Loop );
	}
	TRACE( "command:SS( ... )\n" );
}
/**********************************************************************
	obl~
**********************************************************************/
void CCommandDriver::CommandST( void )
{
	long time = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ST( ... )\n" );
}
/**********************************************************************
	obl̉tԎ擾
**********************************************************************/
void CCommandDriver::CommandSU( void )
{
	long *var1 = m_lpED->GetVariableNo();
	long *var2 = m_lpED->GetVariableNo();

	*var1 = 0;
	*var2 = 0;

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SU( ... )\n" );
}
/**********************************************************************
	wf[^`tł邩ǂ`FbN
**********************************************************************/
void CCommandDriver::CommandSW( void )
{
	long *var	= m_lpED->GetVariableNo();
	long channel= m_lpED->GetExpValue();
	long S_rate	= m_lpED->GetExpValue();
	long bit	= m_lpED->GetExpValue();

	*var = 0; // error not support
	
	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:SW( ... )\n" );
}
/**********************************************************************
	tF[h֘A
**********************************************************************/
void CCommandDriver::CommandSX( void )
{
	long device = m_lpSD->GetParser()->GetC();
	long no		= m_lpSD->GetParser()->GetC();
	long *var;
	long time, volume, stop;
	switch( no ){
		case 0:
			break;
		case 1:
			time = m_lpED->GetExpValue();
			volume=m_lpED->GetExpValue();
			stop = m_lpED->GetExpValue();
			break;
		case 2:
			var = m_lpED->GetVariableNo();
			break;
		case 3:
			break;
		case 4:
			var = m_lpED->GetVariableNo();
			break;
	}

	TRACE( "error:No implement... /" );
	TRACE( "command:SX1( ... )\n" );
}
