/*
 * CommandDriverU.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
using namespace std;
#endif
/**********************************************************************
	U command
**********************************************************************/
void CCommandDriver::_CommandU(void)
{
	switch( m_lpSD->GetParser()->GetC() ){
		case 'C':
			CommandUC(); break;
		case 'D':
			CommandUD(); break;
		case 'G':
			CommandUG(); break;
		case 'P':
			switch( m_lpSD->GetParser()->GetC() ){
				case 0:
					CommandUP0(); break;
				case 1:
					CommandUP1(); break;
				case 3:
					CommandUP3(); break;
				default:
					throw EALSD_Msg( "error: UP? unknown command\n" );
			}
			break;
		case 'R':
			CommandUR(); break;
		case 'S':
			CommandUS(); break;
		default:
			throw EALSD_Msg( "error: U? unknown command\n" );
	}
}

/**********************************************************************
	X^bN폜
**********************************************************************/
void CCommandDriver::CommandUC( void )
{
	long mode = m_lpSD->GetParser()->GetC();
	long num  = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:UC( ... )\n" );
}
/**********************************************************************
	ViI
**********************************************************************/
void CCommandDriver::CommandUD( void )
{
	long mode = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:UD( ... )\n" );
}
/**********************************************************************
	X^bNPOP
**********************************************************************/
void CCommandDriver::CommandUG( void )
{
	long *var = m_lpED->GetVariableNo();
	long count= m_lpED->GetExpValue();

	m_lpSD->GetParser()->PopVar( var, count );
	TRACE( "command:UG( ... )\n" );
}
void CCommandDriver::CommandUP0( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:UP0( ... )\n" );
}
void CCommandDriver::CommandUP1( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:UP1( ... )\n" );
}
/**********************************************************************
	OvONSYSTEM3.6I
**********************************************************************/
void CCommandDriver::CommandUP3( void )
{
	string work;
	string file;
	m_lpSD->GetParser()->GetString( work, '\0');
	m_lpSD->GetParser()->GetString( file, ':' );

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:UP1( ... )\n" );
}

/**********************************************************************
	X^bN̎擾
**********************************************************************/
void CCommandDriver::CommandUR( void )
{
	long *var = m_lpED->GetVariableNo();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:UR( ... )\n" );
}
/**********************************************************************
	X^bNPush
**********************************************************************/
void CCommandDriver::CommandUS( void )
{
	long *var = m_lpED->GetVariableNo();
	long count= m_lpED->GetExpValue();

	m_lpSD->GetParser()->PushVar( var, count );
	TRACE( "command:US( ... )\n" );
}

