/*
 * CommandDriverV.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	V command
**********************************************************************/
void CCommandDriver::_CommandV(void)
{
	switch( m_lpSD->GetParser()->GetC() ){
		case 'A':
			CommandVA(); break;
		case 'B':
			CommandVB(); break;
		case 'C':
			CommandVC(); break;
		case 'E':
			CommandVE(); break;
		case 'F':
			CommandVF(); break;
		case 'G':
			CommandVG(); break;
		case 'H':
			CommandVH(); break;
		case 'I':
			switch( m_lpSD->GetParser()->GetC() ){
				case 'C':
					CommandVIC(); break;
				case 'P':
					CommandVIP(); break;
				default:
					throw EALSD_Msg( "error: VI? unknown command\n" );
			}
			break;
		case 'P':
			CommandVP(); break;
		case 'R':
			CommandVR(); break;
		case 'S':
			CommandVS(); break;
		case 'T':
			CommandVT(); break;
		case 'V':
			CommandVV(); break;
		case 'W':
			CommandVW(); break;
		case 'X':
			CommandVX(); break;
		case 'Z':
			CommandVZ(); break;
		default:
			throw EALSD_Msg( "error: V? unknown command\n" );
	}
}

void CCommandDriver::CommandVA( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VA( ... )\n" );
}
void CCommandDriver::CommandVB( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VB( ... )\n" );
}
void CCommandDriver::CommandVC( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VC( ... )\n" );
}
void CCommandDriver::CommandVE( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VE( ... )\n" );
}
void CCommandDriver::CommandVF( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VF( ... )\n" );
}
void CCommandDriver::CommandVG( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VG( ... )\n" );
}
void CCommandDriver::CommandVH( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VH( ... )\n" );
}
void CCommandDriver::CommandVIC( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VIC( ... )\n" );
}
void CCommandDriver::CommandVIP( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VIP( ... )\n" );
}
void CCommandDriver::CommandVJ( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VJ( ... )\n" );
}
void CCommandDriver::CommandVP( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VP( ... )\n" );
}
void CCommandDriver::CommandVR( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VR( ... )\n" );
}
void CCommandDriver::CommandVS( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VS( ... )\n" );
}
void CCommandDriver::CommandVT( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VT( ... )\n" );
}
void CCommandDriver::CommandVV( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VV( ... )\n" );
}
void CCommandDriver::CommandVW( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VW( ... )\n" );
}
void CCommandDriver::CommandVX( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VX( ... )\n" );
}
void CCommandDriver::CommandVZ( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:VZ( ... )\n" );
}

