/*
 * CommandDriverW.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	W command
**********************************************************************/
void CCommandDriver::_CommandW(void)
{
	switch( m_lpSD->GetParser()->GetC() ) {
		case 'W':
			CommandWW(); break;
		case 'V':
			CommandWV(); break;
		case 'X':
			CommandWX(); break;
		case 'Z':
			CommandWZ0(); break;
	}
}
/**********************************************************************
	ItXN[̃TCY
**********************************************************************/
void CCommandDriver::CommandWW()
{
	long x_size, y_size, color;
	x_size = m_lpED->GetExpValue();
	y_size = m_lpED->GetExpValue();
	color  = m_lpED->GetExpValue();

	TRACE( "command:WW(%d, %d, %d)\n", x_size, y_size, color );
	m_lpGD->SetWorldSize( x_size, y_size, color );
}
/**********************************************************************
	r[|[gTCY
**********************************************************************/
void CCommandDriver::CommandWV()
{
	long start_x, start_y, size_x, size_y;
	start_x = m_lpED->GetExpValue();
	start_y = m_lpED->GetExpValue();
	size_x	= m_lpED->GetExpValue();
	size_y	= m_lpED->GetExpValue();

	m_lpGD->SetViewSize( start_x, start_y, size_x, size_y );

	TRACE( "command:WV(%d, %d, %d, %d)\n",
		start_x, start_y, size_x, size_y );
}

/**********************************************************************
	ʔfON XVꕔ
**********************************************************************/
void CCommandDriver::CommandWX()
{
	stGrpRect update;
	update.left	 = m_lpED->GetExpValue();
	update.top	 = m_lpED->GetExpValue();
	update.right = m_lpED->GetExpValue() + update.left;
	update.bottom= m_lpED->GetExpValue() + update.top;

	m_lpGD->SetUpdate( 1, false );
	m_lpGD->OnDraw( &update );

	TRACE( "command:WX(...)\n" );	
}
/**********************************************************************
	ʔf؂ւ
**********************************************************************/
void CCommandDriver::CommandWZ0()
{
	long p1 = m_lpSD->GetParser()->GetC();
	long sw = m_lpED->GetExpValue();

	if( p1 == 0 ){
		m_lpGD->SetUpdate( sw );
	}

	TRACE( "command:WZ0(...)\n" );	
}


