/*
 * CommandDriverX.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "MessageCtrl.h"
#include "SelectionCtrl.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	X command
**********************************************************************/
void CCommandDriver::_CommandX(void)
{
	long num = m_lpED->GetExpValue() - 1;

	if( m_lpSD->GetSelCtrl()->IsSelecting() ){
		// Io^
		m_lpSD->GetSelCtrl()->AddChoice( m_lpED->GetStrVariable(num) );
	}else{
		// bZ[Wo^
		bool save = m_lpSD->GetMsgCtrl()->GetGetMessage();
		m_lpSD->GetMsgCtrl()->SetGetMessage( false );
		m_lpSD->GetMsgCtrl()->Message( m_lpED->GetStrVariable(num) );
		m_lpSD->GetMsgCtrl()->SetGetMessage( save );
	}
	
	TRACE( "command:X( ... )\n" );
}
