/*
 * CommandDriverY.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"
#include "MessageCtrl.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
#endif
/**********************************************************************
	Y command
**********************************************************************/
void CCommandDriver::_CommandY(void)
{
	static bool by3 = true; // wait̃L[͎t
	long n   = m_lpED->GetExpValue();
	long num = m_lpED->GetExpValue();
	long*var = m_lpED->GetSystemVar();

	switch( n ){
		case 4:
			// Ԃ(ZR)
			if( num > 1 ){
				*var = (long)((double(rand())/RAND_MAX) * num + 1);
			}else{
				*var = num;
			}
			break;
		case 1:
			// bZ[WEBhENA(B0) 
			if( num ){
				m_lpSD->GetMsgCtrl()->Clear( false );
			}else{
				m_lpSD->GetMsgCtrl()->Clear( true );
			}
			break;
		case 2:
			// VXeϐO (NB)
			for( int i = 1;i < 21; i++)var[i] = 0;
			break;
		case 3:
			// wait
			if( num == 0 ){
				*var = CommandIK6_Sub();
			}else if( num == 10000 ){
				by3 = false;
			}else if( num == 10001 ){
				by3 = true;
			}else{
				if( by3 ){
					// L[͎t
					unsigned long time;
					for( int i = 0; i < num / 10; i++){
						time = m_lpGD->GetTickCount();
						if( *var = CommandIK6_Sub() )break;
						time = m_lpGD->GetTickCount() - time;
						if( time < 166 )m_lpGD->Sleep( 166 - time );
					}
				}else{
					m_lpGD->Sleep( 16 * num );
				}
			}
			break;
	}

	TRACE( "command:Y( ... )\n" );
}
