/*
 * CommandDriverZ.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "CommandDriver.h"

#include <ctime>
#include "ScenarioDecoder.h"
#include "ScenarioParser.h"
#include "ExpressionDriver.h"
#include "GraphicDriver.h"
#include "MessageCtrl.h"
#include "SelectionCtrl.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_CMDDRV;
using namespace std;
#endif
/**********************************************************************
	Z command
**********************************************************************/
void CCommandDriver::_CommandZ(void)
{
	long Cmd = m_lpSD->GetParser()->GetC();
	switch( Cmd ){
		case 'T':
			CommandZT(); break;
		case 'A':
			CommandZA(); break;
		case 'B':
			CommandZB(); break;
		case 'C':
			CommandZC(); break;
		case 'D':
			CommandZD(); break;
		case 'E':
			CommandZE(); break;
		case 'F':
			CommandZF(); break;
		case 'G':
			CommandZG(); break;
		case 'H':
			CommandZH(); break;
		case 'I':
			CommandZI(); break;
		case 'K':
			CommandZK(); break;
		case 'L':
			CommandZL(); break;
		case 'M':
			CommandZM(); break;
		case 'R':
			CommandZR(); break;
		case 'S':
			CommandZS(); break;

		case 'W':
			CommandZW(); break;
		case 'Z':
			CommandZZ(); break;
		default:
			throw EALSD_Msg( "error: Z? unknown command\n" );
	}
}
/**********************************************************************
	ݒ	
**********************************************************************/
void CCommandDriver::CommandZA( void )
{
	long no = m_lpSD->GetParser()->GetC();
	long arg2=m_lpED->GetExpValue();

	switch( no ){
		case 0:	// ̎ނw肷
			m_lpGD->SetDecorateType( arg2 );
			break;
		case 1: // ɗpF̎w arg2 = palette index
			m_lpGD->SetDecorateColor( arg2 );
			break;
		case 3: // y[W 0:Off 1:On
			if( arg2 ){
				m_lpSD->GetMsgCtrl()->SetAutoNextPage( true );
			}else{
				m_lpSD->GetMsgCtrl()->SetAutoNextPage( false );
			}
			break;
	}

	TRACE( "command:ZA( ... )\n" );
}
/**********************************************************************
	bZ[W̎w
**********************************************************************/
void CCommandDriver::CommandZB( void )
{
	long size = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZB( ... )\n" );
}
/**********************************************************************
	VXe̎gpύX
**********************************************************************/
void CCommandDriver::CommandZC( void )
{
	long m = m_lpED->GetExpValue();
	long n = m_lpED->GetExpValue();

	switch( m ){
		case  0:break;
		case  1: m_lpSD->GetMsgCtrl()->SetFontColor( n );break;
		case  2: m_lpSD->GetSelCtrl()->SetFontColor( n );break;
		case  3: m_lpSD->GetSelCtrl()->SetFrameColor(n );break;
		case  4: m_lpSD->GetSelCtrl()->SetBackColor( n );break;
		case  5: m_lpSD->GetMsgCtrl()->SetFrameColor(n );break;
		case  6: m_lpSD->GetMsgCtrl()->SetBackColor( n );break;
		case  7: m_lpSD->GetMsgCtrl()->SetMarkColor( n );break;
		case 10: m_lpSD->GetSelCtrl()->SetCurType( n );  break;
		case 11: m_lpSD->GetSelCtrl()->SetSeleColor( n );break;
		case 13: m_lpSD->GetMsgCtrl()->SetClearAlpha( n ); break;
		case 14: m_lpSD->GetSelCtrl()->SetColorKey( n ); break;
		default:
			throw EALSD_Msg( "error: ZC unknown param\n" );
	}

	TRACE( "command:ZC( ... )\n" );
}
/**********************************************************************
	fobO[h̃fobObZ[W̏o ON/OFF/PAUSE
**********************************************************************/
void CCommandDriver::CommandZD( void )
{
	long no = m_lpSD->GetParser()->GetC();
	long sw, num;
	long *var;
	
	switch( no ){
		case 0:
		case 1:
			sw = m_lpED->GetExpValue();
			break;
		case 2:
			num = m_lpED->GetExpValue() - 1;
			break;
		case 3:
			num = m_lpED->GetExpValue();
			break;
		case 4:
			var = m_lpED->GetVariableNo();
			*var = 0;
			break;
	}

	TRACE( "error:[Half] implement... /" );
	TRACE( "command:ZD( ... )\n" );
}
/**********************************************************************
	II񂾂烁bZ[ẄNA̐ݒ
**********************************************************************/
void CCommandDriver::CommandZE( void )
{
	long sw = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZE( ... )\n" );
}
/**********************************************************************
	IgTCYςɂ邩Œɂ邩w
**********************************************************************/
void CCommandDriver::CommandZF( void )
{
	long sw = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZF( ... )\n" );
}
/**********************************************************************
	bf̃[h񐔂Nԍɔzɏޔzݒ
**********************************************************************/
void CCommandDriver::CommandZG( void )
{
	long *var = m_lpED->GetVariableNo();

	m_lpGD->SetCGLoadCount( var );

	TRACE( "command:ZG( ... )\n" );
}
/**********************************************************************
	Spp؂ւ
**********************************************************************/
void CCommandDriver::CommandZH( void )
{
	long sw = m_lpED->GetExpValue();

	bool bsw = false;
	if(sw)bsw= true;
	m_lpSD->GetMsgCtrl()->SetHankaku( bsw );
		
	TRACE( "command:ZH( ... )\n" );
}
/**********************************************************************
	`R}h̃L[͑҂̊eL[̓̎w
**********************************************************************/
void CCommandDriver::CommandZI( void )
{
	long key  = m_lpED->GetExpValue();
	long mode = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZI( ... )\n" );
}
void CCommandDriver::CommandZK( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:ZK( ... )\n" );
}
/**********************************************************************
	bZ[Wcsԃhbg̐ݒ
**********************************************************************/
void CCommandDriver::CommandZL( void )
{
	long line = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZL( ... )\n" );
}
/**********************************************************************
	tHgTCY̕ύX
**********************************************************************/
void CCommandDriver::CommandZM( void )
{
	long size = m_lpED->GetExpValue();

	m_lpSD->GetMsgCtrl()->SetFontSize( size );
	TRACE( "command:ZM( ... )\n" );
}
/**********************************************************************
	ĨtHgTCY̕ύX
**********************************************************************/
void CCommandDriver::CommandZS( void )
{
	long size = m_lpED->GetExpValue();

	m_lpSD->GetSelCtrl()->SetFontSize( size );
	TRACE( "command:ZS( ... )\n" );
}
/**********************************************************************
	
**********************************************************************/
void CCommandDriver::CommandZR( void )
{
	long num = m_lpED->GetExpValue();
	long*var = m_lpED->GetVariableNo();

	if( num ){
		*var = (long)((double(rand())/RAND_MAX) * num + 1);
	}else{
		*var = 0;
	}

	TRACE( "command:ZR( ... )\n" );
}
/**********************************************************************
	CAPSԂ̓IύXB
**********************************************************************/
void CCommandDriver::CommandZW( void )
{
	long sw = m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZW( ... )\n" );
}
/**********************************************************************
	ys
**********************************************************************/
void CCommandDriver::CommandZT( void )
{
	switch( m_lpSD->GetParser()->GetC() ){
		case 5:
			CommandZT5(); break;
		case 3:
			CommandZT3(); break;
		case 0:
			CommandZT0(); break;
		case 1:
			CommandZT1(); break;
		case 2:
			CommandZT2(); break;
		case 4:
			CommandZT4(); break;
		case 10:
			CommandZT10();break;
		case 11:
			CommandZT11();break;
		default:
			throw EALSD_Msg( "error: ZT? unknown command\n" );
	}
}

/**********************************************************************
	݂̓ϐɕԂ
**********************************************************************/
void CCommandDriver::CommandZT0( void )
{
	long *var = m_lpED->GetVariableNo();

	time_t LocalTime;
	time( &LocalTime );

	tm *NowTime;
	NowTime = localtime( &LocalTime );

	var[0] = NowTime->tm_year	+ 1900;
	var[1] = NowTime->tm_mon	+ 1;
	var[2] = NowTime->tm_mday;
	var[3] = NowTime->tm_hour;
	var[4] = NowTime->tm_min;
	var[5] = NowTime->tm_sec;

	TRACE( "command:ZT0( ... )\n" );
}
/**********************************************************************
	^C}̒lNA
**********************************************************************/
void CCommandDriver::CommandZT1( void )
{
	long n = m_lpED->GetExpValue();

	m_NowTime = n;
	m_lpGD->GetTickCount( &m_OffsetTime );
	TRACE( "command:ZT1( ... )\n" );
}
/**********************************************************************
	^C}擾 1/10sec
**********************************************************************/
void CCommandDriver::CommandZT2( void )
{
	unsigned long time;
	long *var = m_lpED->GetVariableNo();
	m_lpGD->GetTickCount( &time );

	*var = ( time - m_OffsetTime )/100 + m_NowTime;
	TRACE( "command:ZT2( ... )\n" );
}
/**********************************************************************
	^C}擾 1/30sec
**********************************************************************/
void CCommandDriver::CommandZT3( void )
{
	unsigned long time;
	long *var = m_lpED->GetVariableNo();
	m_lpGD->GetTickCount( &time );

	*var = ( time - m_OffsetTime )/33 + m_NowTime;
	TRACE( "command:ZT3( ... )\n" );
}
/**********************************************************************
	^C}擾 1/60sec
**********************************************************************/
void CCommandDriver::CommandZT4( void )
{
	unsigned long time;
	long *var = m_lpED->GetVariableNo();
	m_lpGD->GetTickCount( &time );

	*var = ( time - m_OffsetTime )/17 + m_NowTime;
	TRACE( "command:ZT4( ... )\n" );
}
/**********************************************************************
	^C}擾 1/100sec
**********************************************************************/
void CCommandDriver::CommandZT5( void )
{
	unsigned long time;
	long *var = m_lpED->GetVariableNo();
	m_lpGD->GetTickCount( &time );

	*var = ( time - m_OffsetTime )/10 + m_NowTime;
	TRACE( "command:ZT5( ... )\n" );
}
/**********************************************************************
	x^C}[ݒ
**********************************************************************/
void CCommandDriver::CommandZT10( void )
{
	long num  = m_lpED->GetExpValue();
	long base = m_lpED->GetExpValue();
	long count= m_lpED->GetExpValue();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZT10( ... )\n" );
}
/**********************************************************************
	x^C}[擾
**********************************************************************/
void CCommandDriver::CommandZT11( void )
{
	long num = m_lpED->GetExpValue();
	long*var = m_lpED->GetVariableNo();

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZT11( ... )\n" );
}
/**********************************************************************
	yy
**********************************************************************/
void CCommandDriver::CommandZZ( void )
{
	long Cmd = m_lpSD->GetParser()->GetC();
	switch( Cmd ){
		case 0:
			CommandZZ0(); break;
		case 1:
			CommandZZ1(); break;
		case 2:
			CommandZZ2(); break;
		case 3:
			CommandZZ3(); break;
		case 4:
			CommandZZ4(); break;
		case 5:
			CommandZZ5(); break;
		case 6:
			CommandZZ6(); break;
		case 7:
			CommandZZ7(); break;
		case 8:
			CommandZZ8(); break;
		case 9:
			CommandZZ9(); break;
		case 10:
			CommandZZ10(); break;
		case 11:
			CommandZZ11(); break;
		case 12:
			CommandZZ12(); break;
		case 13:
			CommandZZ13(); break;
		default:
			throw EALSD_Msg( "error: ZZ? unknown command\n" );
	}
}
/**********************************************************************
	scenario decoder I
**********************************************************************/
void CCommandDriver::CommandZZ0( void )
{
	long sw = m_lpED->GetExpValue();
	
	*m_lpED->GetSystemVar() = 1;

	throw EALSD_Exit();
	TRACE( "error:[Half] implement... /" );
	TRACE( "command:ZZ0 \n" );
}
/**********************************************************************
	scenario decoder I
**********************************************************************/
void CCommandDriver::CommandZZ1( void )
{
	long *var = m_lpED->GetVariableNo();
	
	*m_lpED->GetSystemVar() = 255;	

	TRACE( "error:[Half] implement... /" );
	TRACE( "command:ZZ1( ... )\n" );
}
/**********************************************************************
	@핶𕶎̈ɕԂiMAXSpPQ
**********************************************************************/
void CCommandDriver::CommandZZ2( void )
{
	long num = m_lpED->GetExpValue() - 1;
	string str;
	m_lpGD->GetSystemName( str );
	
	strcpy( m_lpED->GetStrVariable(num), str.c_str() ); 	
	TRACE( "command:ZZ2( ... )\n" );
}
/**********************************************************************
	Window̑SʃTCY\FԂ
**********************************************************************/
void CCommandDriver::CommandZZ3( void )
{
	long *var = m_lpED->GetVariableNo();

	// 
	var[0] = 1024;
	var[1] =  768;
	var[2] =   32;
	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZZ3( ... )\n" );
}
/**********************************************************************
	DIB̑SʃTCYFϐɕԂ
**********************************************************************/
void CCommandDriver::CommandZZ4( void )
{
	long *var = m_lpED->GetVariableNo();

	m_lpGD->GetWorldSize( var, var + 1, var + 2 );

	TRACE( "command:ZZ4( ... )\n" );
}
/**********************************************************************
	r[TCYԂ
**********************************************************************/
void CCommandDriver::CommandZZ5( void )
{
	long *var = m_lpED->GetVariableNo();

	m_lpGD->GetViewSize( var, var + 1, var + 2 );

	TRACE( "command:ZZ5( ... )\n" );
}
/**********************************************************************
**********************************************************************/
void CCommandDriver::CommandZZ6( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:ZZ6( ... )\n" );
}
/**********************************************************************
	Z[uhCu̎cfBXNeʂ擾
**********************************************************************/
void CCommandDriver::CommandZZ7( void )
{
	long *var = m_lpED->GetVariableNo();

	*var = 65535;
	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZZ7( ... )\n" );
}
/**********************************************************************
	Iobt@̎ceʂ擾
**********************************************************************/
void CCommandDriver::CommandZZ8( void )
{
	long *var = m_lpED->GetVariableNo();

	*var = 65535;
	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZZ8( ... )\n" );
}
/**********************************************************************
	ÑXN[TCY𓾂
**********************************************************************/
void CCommandDriver::CommandZZ9( void )
{
	long *var = m_lpED->GetVariableNo();

	var[0] = 1152;
	var[1] =  864;
	var[2] =   32;

	TRACE( "error:[Dummy] implement... /" );
	TRACE( "command:ZZ9( ... )\n" );
}
/**********************************************************************
**********************************************************************/
void CCommandDriver::CommandZZ10( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:ZZ10( ... )\n" );
}
/**********************************************************************
**********************************************************************/
void CCommandDriver::CommandZZ11( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:ZZ11( ... )\n" );
}
/**********************************************************************
**********************************************************************/
void CCommandDriver::CommandZZ12( void )
{
	TRACE( "error:No implement... /" );
	TRACE( "command:ZZ12( ... )\n" );
}
/**********************************************************************
	tHgύX
**********************************************************************/
void CCommandDriver::CommandZZ13( void )
{
	long num = m_lpED->GetExpValue();

	m_lpGD->SetFont( num );
	TRACE( "command:ZZ13( ... )\n" );
}

