/*
 * EFiles.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __EFiles_h__
#define __EFiles_h__
/**********************************************************************
	file exception
	
**********************************************************************/
#include "ExceptionBase.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace err{
#endif
	class EFile;
	class EFileOpen;
	const char *const MSG_FileOpen = "error:Cannot open the file(%s).";
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
}
#endif
//
// base class define
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class err::EFile : public err::Exception {
#else
class EFile : public Exception {
#endif
public:
	EFile( const char *_lpFileName )	{ m_strFileName = _lpFileName;};
	virtual ~EFile(){};
protected:
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	std::string	m_strFileName;
#else
	string	m_strFileName;
#endif
	
	void strMessage( FILE *_fp, const char *_Msg ){
		fprintf( _fp, _Msg, m_strFileName.c_str() );
	};
};

//
// FileOpen
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class err::EFileOpen : public err::EFile {
#else
class EFileOpen : public EFile {
#endif
public:
	//
	EFileOpen( const char *_lpFileName ) 	: EFile(_lpFileName){};
	virtual ~EFileOpen(){};
	//
	void Message(FILE *fp = stderr){ strMessage( fp, MSG_FileOpen );};
};

#endif

