/*
 * FileData.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __FileData_h__
#define __FileData_h__
/**********************************************************************
	file data in ALD file.
	
**********************************************************************/
#include "ScenarioDecoderSystem.h"
//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD {
#endif
	class CFileData;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

//
// class
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class ALSD::CFileData {
#else
class CFileData {
#endif
public:
	//
	CFileData();
	virtual ~CFileData();
	
	HRESULT Destroy(void);
	
	// Agr[gANZX
	void SetType( FILEDATATYPE _Type ){ m_Type = _Type;};
	void SetNo( long _No ){ m_No = _No;};
	void SetName( const char *_lpName ){ strcpy(m_lpName, _lpName);};
	void SetData( const char *_lpData, long _Size );

	char *GetData( void ) const { return m_lpData;};
protected:
	//
	FILEDATATYPE	 m_Type;		// file type
	long			 m_No;			// file number
	char			 m_lpName[256];	// file name
	long			 m_Size;		// file size
	char			*m_lpData;		// file data

private:
};

#endif
