/*
 * GraphicDriverBlt.cpp 
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "GraphicDriver.h"

#include "OffScreen.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_OFFSCR;
#endif
/**********************************************************************
	hԂ
**********************************************************************/
void CGraphicDriver::Paint( long _x, long _y, unsigned char _c )
{
	// `ǂ悤...
}

/**********************************************************************
	v[̃NA
**********************************************************************/
void CGraphicDriver::ClearAlpha ( unsigned char _a8 )
{
	// bN
	stGrpScreenDesc Desc;
	stGrpScreenBits Bits;
	m_lpScreen->Lock( &Bits, &Desc );
	//
	memset( Bits.lpABits, _a8, Desc.dwWidth * Desc.dwHeight );

	// AbN
	m_lpScreen->Unlock();
}
/**********************************************************************
	J[v[̃NA
**********************************************************************/
void CGraphicDriver::ClearColor ( unsigned long _rgb32 )
{
	// bN
	stGrpScreenDesc Desc;
	stGrpScreenBits Bits;
	m_lpScreen->Lock( &Bits, &Desc );
	//
	memset( Bits.lpCBits, _rgb32, Desc.dwWidth * Desc.dwHeight * 4 );

	// AbN
	m_lpScreen->Unlock();
}

/**********************************************************************
	rbgubg
**********************************************************************/
void CGraphicDriver::BltFast( long _sx, long _sy, long _sw, long _sh,
							  long _dx, long _dy )
{
	long sright = _sx + _sw;
	long sbottom= _sy + _sh;
	long dright = _dx + _sw;
	long dbottom= _dy + _sh;

	// `dȂ邩ǂ肷
	if( ( sright  <= _dx || _sx  >= dright ) ||
		( sbottom <= _dy || _sy  >= dbottom)		){
		// dȂȂ
		BltFast32( _sx, _sy, _sw, _sh, _dx, _dy );
		return ;
	}
	
	// dȂ
	BltFast32c( _sx, _sy, _sw, _sh, _dx, _dy );

	return;
}

/**********************************************************************
	PRs[
**********************************************************************/
void CGraphicDriver::BltFast32(	long _sx, long _sy, long _sw, long _sh,
								long _dx, long _dy )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// ʒu
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = Bits.lpCBits;
	lpSrcPos += ( _sx + _sy * pitch );
	unsigned long *lpDstPos = Bits.lpCBits;
	lpDstPos += ( _dx + _dy * pitch );
	unsigned char *lpASrcPos =Bits.lpABits;
	lpASrcPos +=( _sx + _sy * pitch );
	unsigned char *lpADstPos =Bits.lpABits;
	lpADstPos +=( _dx + _dy * pitch );
	
	//
	for( long i = 0; i < _sh; i++ ){
		memcpy( lpDstPos, lpSrcPos, _sw * 4 );
		lpSrcPos += pitch;
		lpDstPos += pitch;
	}
	for( long i = 0; i < _sh; i++){
		memcpy( lpADstPos, lpASrcPos, _sw );
		lpASrcPos+= pitch;
		lpADstPos+= pitch;
	}

	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	dȂĂCaks
**********************************************************************/
void CGraphicDriver::BltFast32c(long _sx, long _sy, long _sw, long _sh,
								long _dx, long _dy )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;
	// obNAbv
	BltFast32b( _sx, _sy, _sw, _sh, &Bits, &Desc );

	// ʒu
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = Bits.lpBackupCBits;
	lpSrcPos += ( _sx + _sy * pitch );
	unsigned long *lpDstPos = Bits.lpCBits;
	lpDstPos += ( _dx + _dy * pitch );
	unsigned char *lpASrcPos =Bits.lpBackupABits;
	lpASrcPos +=( _sx + _sy * pitch );
	unsigned char *lpADstPos =Bits.lpABits;
	lpADstPos +=( _dx + _dy * pitch );
	
	//
	for( long i = 0; i < _sh; i++ ){
		memcpy( lpDstPos, lpSrcPos, _sw * 4 );
		lpSrcPos += pitch;
		lpDstPos += pitch;
		
		memcpy( lpADstPos,lpASrcPos, _sw );
		lpASrcPos+= pitch;
		lpADstPos+= pitch;
	}

	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	aksobNAbv
**********************************************************************/
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
void CGraphicDriver::BltFast32b(long _sx, long _sy, long _sw, long _sh, 
								ALSD_OFFSCR::stGrpScreenBits *_lpBits, 
								ALSD_OFFSCR::stGrpScreenDesc *_lpDesc )
#else
void CGraphicDriver::BltFast32b(long _sx, long _sy, long _sw, long _sh, 
								stGrpScreenBits *_lpBits, 
								stGrpScreenDesc *_lpDesc )
#endif
{
	TRACE(" ......:Backup offscreen...\n" );

	// ʒu
	long pitch = _lpDesc->lPitch / 4;
	long pos = ( _sx + _sy * pitch );
	unsigned long *lpSrcPos = _lpBits->lpCBits;
	lpSrcPos += pos;
	unsigned long *lpDstPos = _lpBits->lpBackupCBits;
	lpDstPos += pos;
	unsigned char *lpASrcPos =_lpBits->lpABits;
	lpASrcPos +=pos;
	unsigned char *lpADstPos =_lpBits->lpBackupABits;
	lpADstPos +=pos;
	
	//
	for( long i = 0; i < _sh; i++ ){
		memcpy( lpDstPos, lpSrcPos, _sw * 4 );
		lpSrcPos += pitch;
		lpDstPos += pitch;
		
		memcpy( lpADstPos,lpASrcPos, _sw );
		lpASrcPos+= pitch;
		lpADstPos+= pitch;
	}
}

/**********************************************************************
	gEkE]aks
**********************************************************************/
void CGraphicDriver::BltMirror( stGrpRect *_lpSrcRect,
							    stGrpRect *_lpDstRect, long _mf )
{
//	m_lpScreen->BltMirror( _lpSrcRect, _lpDstRect, _mf );
	// `dȂ邩ǂ肷
	if( _lpSrcRect->right  <= _lpDstRect->left ||
		_lpSrcRect->left   >= _lpDstRect->right||
		_lpSrcRect->bottom <= _lpDstRect->top  ||
		_lpSrcRect->top    >= _lpDstRect->bottom ){
		// dȂȂ
		BltMirror32( _lpSrcRect, _lpDstRect, _mf );
		return ;
	}
	
	// dȂ
	BltMirror32c( _lpSrcRect, _lpDstRect, _mf );

	return;
}

/**********************************************************************
	gk]a
*********************************************************************/
void CGraphicDriver::BltMirror32( stGrpRect *_lpSrcRect,
									stGrpRect *_lpDstRect,
			 						long _MirrorFlag )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// g嗦߂
	float st1x = (float)( _lpDstRect->right - _lpDstRect->left ) /
				 (float)( _lpSrcRect->right - _lpSrcRect->left );
	float st1y = (float)( _lpDstRect->bottom- _lpDstRect->top  ) /
				 (float)( _lpSrcRect->bottom- _lpSrcRect->top  );
	st1x = 1.0f / st1x;
	st1y = 1.0f / st1y;

	// ʒu|C^
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = (unsigned long *)Bits.lpCBits;
	lpSrcPos += ( _lpSrcRect->left + _lpSrcRect->top * pitch );
	unsigned long *lpDstPos = (unsigned long *)Bits.lpCBits;
	lpDstPos += ( _lpDstRect->left + _lpDstRect->top * pitch );
	unsigned char *lpASrcPos = (unsigned char *)Bits.lpABits;
	lpASrcPos += ( _lpSrcRect->left + _lpSrcRect->top * pitch );
	unsigned char *lpADstPos = (unsigned char *)Bits.lpABits;
	lpADstPos += ( _lpDstRect->left + _lpDstRect->top * pitch );

	int lsize= _lpDstRect->right - _lpDstRect->left;
	int loop = _lpDstRect->bottom- _lpDstRect->top;
	int sw   = _lpSrcRect->right - _lpSrcRect->left;
	int sh   = _lpSrcRect->bottom- _lpSrcRect->top;

	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	int sx, sy;

	for( int y = 0; y < loop; y++ ){ // c[v
		lpDstPosWork = lpDstPos;
		lpADstPosWork = lpADstPos;
		for( int x = 0; x < lsize; x++ ){
			// \[X̍W𓾂
			sx = (int)( (float)x * st1x );
			sy = (int)( (float)y * st1y );
			if( _MirrorFlag & 0x00000001 ){
				// ㉺]
				sy = sh - sy - 1;
			}
			if( _MirrorFlag & 0x00000002 ){
				// E]
				sx = sw - sx - 1;
			}
			lpSrcPosWork = lpSrcPos   + ( sx + sy * pitch );
			*lpDstPosWork =	*lpSrcPosWork;
			lpASrcPosWork = lpASrcPos + ( sx + sy * pitch );
			*lpADstPosWork =*lpASrcPosWork;
			
			lpDstPosWork++;
			lpADstPosWork++;
		}
		lpDstPos  += pitch;
		lpADstPos += pitch;
	}

	//
	m_lpScreen->Unlock();

}

/**********************************************************************
	gk]adȂĂC
*********************************************************************/
void CGraphicDriver::BltMirror32c(	stGrpRect *_lpSrcRect,
									stGrpRect *_lpDstRect,
			 						long _MirrorFlag )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;
	// obNAbv
	BltFast32b( _lpSrcRect->left,
				_lpSrcRect->top,
				_lpSrcRect->right - _lpSrcRect->left,
				_lpSrcRect->bottom- _lpSrcRect->top,
				&Bits, &Desc );
	
	// g嗦߂
	float st1x = (float)( _lpDstRect->right - _lpDstRect->left ) /
				 (float)( _lpSrcRect->right - _lpSrcRect->left );
	float st1y = (float)( _lpDstRect->bottom- _lpDstRect->top  ) /
				 (float)( _lpSrcRect->bottom- _lpSrcRect->top  );
	st1x = 1.0f / st1x;
	st1y = 1.0f / st1y;

	// ʒu|C^
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = (unsigned long *)Bits.lpBackupCBits;
	lpSrcPos += ( _lpSrcRect->left + _lpSrcRect->top * pitch );
	unsigned long *lpDstPos = (unsigned long *)Bits.lpCBits;
	lpDstPos += ( _lpDstRect->left + _lpDstRect->top * pitch );
	unsigned char *lpASrcPos = (unsigned char *)Bits.lpBackupABits;
	lpASrcPos += ( _lpSrcRect->left + _lpSrcRect->top * pitch );
	unsigned char *lpADstPos = (unsigned char *)Bits.lpABits;
	lpADstPos += ( _lpDstRect->left + _lpDstRect->top * pitch );

	int loop = _lpDstRect->bottom- _lpDstRect->top;
	int lsize= _lpDstRect->right - _lpDstRect->left;
	int sw = _lpSrcRect->right - _lpSrcRect->left;
	int sh = _lpSrcRect->bottom- _lpSrcRect->top;

	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	int sx, sy;

	for( int y = 0; y < loop; y++ ){ // c[v
		lpDstPosWork = lpDstPos;
		lpADstPosWork = lpADstPos;
		for( int x = 0; x < lsize; x++ ){
			// \[X̍W𓾂
			sx = (int)( (float)x * st1x );
			sy = (int)( (float)y * st1y );
			if( _MirrorFlag & 0x00000001 ){
				// ㉺]
				sy = sh - sy - 1;
			}
			if( _MirrorFlag & 0x00000002 ){
				// E]
				sx = sw - sx - 1;
			}
			lpSrcPosWork  =  lpSrcPos  + ( sx + sy * pitch );
			*lpDstPosWork =	*lpSrcPosWork;
			lpASrcPosWork =  lpASrcPos + ( sx + sy * pitch );
			*lpADstPosWork= *lpASrcPosWork;
			
			lpDstPosWork++;
			lpADstPosWork++;
		}
		lpDstPos  += pitch;
		lpADstPos += pitch;
	}
	//
	m_lpScreen->Unlock();
}

/**********************************************************************
	XvCgtBitBlt
**********************************************************************/
void CGraphicDriver::BltSprite( long _sx, long _sy, long _sw, long _sh,
							    long _dx, long _dy, unsigned char _c )
{
	long sright = _sx + _sw;
	long sbottom= _sy + _sh;
	long dright = _dx + _sw;
	long dbottom= _dy + _sh;

	// `dȂ邩ǂ肷
	if( ( sright  <= _dx || _sx  >= dright ) ||
		( sbottom <= _dy || _sy  >= dbottom)		){
		// dȂȂ
		BltSprite32( _sx, _sy, _sw, _sh, _dx, _dy, _c );
		return ;
	}
	
	// dȂ
	BltSprite32c( _sx, _sy, _sw, _sh, _dx, _dy, _c );
	return;
}

/**********************************************************************
	PXvCg
**********************************************************************/
void CGraphicDriver::BltSprite32(long _sx, long _sy, long _sw, long _sh,
								 long _dx, long _dy, unsigned char _c )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = ( (long)m_Palette.entry[_c].red  << 16 ) |
						( (long)m_Palette.entry[_c].green<<  8 ) |
						( (long)m_Palette.entry[_c].blue	   );

	// ʒu
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = Bits.lpCBits;
	lpSrcPos += ( _sx + _sy * pitch );
	unsigned long *lpDstPos = Bits.lpCBits;
	lpDstPos += ( _dx + _dy * pitch );
	unsigned char *lpASrcPos =Bits.lpABits;
	lpASrcPos +=( _sx + _sy * pitch );
	unsigned char *lpADstPos =Bits.lpABits;
	lpADstPos +=( _dx + _dy * pitch );
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	//
	for( long i = 0; i < _sh; i++ ){
		lpSrcPosWork  = lpSrcPos;
		lpDstPosWork  = lpDstPos;
		lpASrcPosWork = lpASrcPos;
		lpADstPosWork = lpADstPos;
		for( long x = 0; x < _sw; x++ ){
			if( *lpSrcPosWork != key ){
				*lpDstPosWork = *lpSrcPosWork;
				*lpADstPosWork= *lpASrcPosWork;
			}
			lpSrcPosWork++;
			lpDstPosWork++;
			lpASrcPosWork++;
			lpADstPosWork++;
		}
		lpSrcPos += pitch;
		lpDstPos += pitch;
		lpASrcPos+= pitch;
		lpADstPos+= pitch;
	}

	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	PXvCg
**********************************************************************/
void CGraphicDriver::BltSprite32c(long _sx, long _sy, long _sw, long _sh,
								  long _dx, long _dy, unsigned char _c )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;
	// obNAbv
	BltFast32b( _sx, _sy, _sw, _sh, &Bits, &Desc );

	// J[L[
	unsigned long key = ( (long)m_Palette.entry[_c].red  << 16 ) |
						( (long)m_Palette.entry[_c].green<<  8 ) |
						( (long)m_Palette.entry[_c].blue	   );

	// ʒu
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = Bits.lpBackupCBits;
	lpSrcPos += ( _sx + _sy * pitch );
	unsigned long *lpDstPos = Bits.lpCBits;
	lpDstPos += ( _dx + _dy * pitch );
	unsigned char *lpASrcPos =Bits.lpBackupABits;
	lpASrcPos +=( _sx + _sy * pitch );
	unsigned char *lpADstPos =Bits.lpABits;
	lpADstPos +=( _dx + _dy * pitch );
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	//
	for( long i = 0; i < _sh; i++ ){
		lpSrcPosWork  = lpSrcPos;
		lpDstPosWork  = lpDstPos;
		lpASrcPosWork = lpASrcPos;
		lpADstPosWork = lpADstPos;
		for( long x = 0; x < _sw; x++ ){
			if( *lpSrcPosWork != key ){
				*lpDstPosWork = *lpSrcPosWork;
				*lpADstPosWork= *lpASrcPosWork;
			}
			lpSrcPosWork++;
			lpDstPosWork++;
			lpASrcPosWork++;
			lpADstPosWork++;
		}
		lpSrcPos += pitch;
		lpDstPos += pitch;
		lpASrcPos+= pitch;
		lpADstPos+= pitch;
	}

	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	aa
**********************************************************************/
void CGraphicDriver::BltWithAlpha( long _sx, long _sy, long _sw, long _sh,
								   long _dx, long _dy )
{
	long sright = _sx + _sw;
	long sbottom= _sy + _sh;
	long dright = _dx + _sw;
	long dbottom= _dy + _sh;

	// `dȂ邩ǂ肷
	if( ( sright  <= _dx || _sx  >= dright ) ||
		( sbottom <= _dy || _sy  >= dbottom)		){
		// dȂȂ
		BltWithAlpha32( _sx, _sy, _sw, _sh, _dx, _dy );
		return ;
	}
	
	// dȂ
	BltWithAlpha32( _sx, _sy, _sw, _sh, _dx, _dy );

	return;
}

/**********************************************************************
	aa
**********************************************************************/
void CGraphicDriver::BltWithAlpha32( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// ʒu
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = Bits.lpCBits;
	lpSrcPos += ( _sx + _sy * pitch );
	unsigned long *lpDstPos = Bits.lpCBits;
	lpDstPos += ( _dx + _dy * pitch );
	unsigned char *lpASrcPos =Bits.lpABits;
	lpASrcPos +=( _sx + _sy * pitch );
	unsigned char *lpADstPos =Bits.lpABits;
	lpADstPos +=( _dx + _dy * pitch );
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	long sr, sg, sb, sa;
	long dr, dg, db, da;
	//
	for( long i = 0; i < _sh; i++ ){
		lpSrcPosWork  = lpSrcPos;
		lpDstPosWork  = lpDstPos;
		lpASrcPosWork = lpASrcPos;
		lpADstPosWork = lpADstPos;
		for( long x = 0; x < _sw; x++ ){
			sr = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
			sg = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
			sb = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwBBitMask);
			sa = (*lpASrcPosWork) >> ALSD_ABTABLE_BITS;

			dr = (*lpDstPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
			dg = (*lpDstPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
			db = (*lpDstPosWork & Desc.dgpfPixelFormat.dwBBitMask);
			da = ALSD_ABTABLE_DEPTH - 1 - sa;

			sr = m_AlphaBlendTable[da][dr] + m_AlphaBlendTable[sa][sr];
			sg = m_AlphaBlendTable[da][dg] + m_AlphaBlendTable[sa][sg];
			sb = m_AlphaBlendTable[da][db] + m_AlphaBlendTable[sa][sb];
					
			*lpDstPosWork = sr << 16 | sg << 8 | sb ;

			lpSrcPosWork++;
			lpDstPosWork++;
			lpASrcPosWork++;
//			lpADstPosWork++;
		}
		lpSrcPos += pitch;
		lpDstPos += pitch;
		lpASrcPos+= pitch;
		lpADstPos+= pitch;
	}

	// Unlock
	m_lpScreen->Unlock();
}
