/*
 * GraphicDriverBltEffect.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "GraphicDriver.h"

#include "OffScreen.h"
#include "CommandDriver.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_ALCG;
using namespace ALSD_OFFSCR;
#endif
/**********************************************************************
	GtFNgaa
**********************************************************************/
void CGraphicDriver::BltEffect( long _sx, long _sy, long _sw, long _sh, 
								long _dx, long _dy, long _ef, long _op,
								long _wf, long _sc )
{
	if( _dx < m_ViewRect.left ){
		_sw = _sw - ( m_ViewRect.left - _dx ); 
		_dx = m_ViewRect.left;
	}
	if( _dy < m_ViewRect.top  ){
		_sh = _sh - ( m_ViewRect.top - _dy );
		_dy = m_ViewRect.top;
	}
	
	switch( _ef ){
		case 1:
			BltEffect32_01( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 2:
			BltEffect32_02( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 3:
			BltEffect32_03( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 4:
			BltEffect32_04( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 5:
			BltEffect32_05( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 6:
			BltEffect32_06( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 7:
			BltEffect32_07( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 8:
			BltEffect32_08( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 9:
			BltEffect32_09( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 11:
			BltEffect32_11( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 12:
			BltEffect32_12( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 13:
			BltEffect32_13( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 14:
			BltEffect32_14( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 16:
			BltEffect32_16( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 17:
			BltEffect32_17( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 18:
			BltEffect32_18( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 19:
			BltEffect32_19( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 20:
			BltEffect32_20( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 21:
			BltEffect32_21( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 22:
			BltEffect32_22( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 23:
			BltEffect32_23( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 27:
			BltEffect32_27( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 29:
			BltEffect32_29( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 28:
			BltEffect32_28( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 30:
			BltEffect32_30( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 31:
			BltEffect32_31( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 2000:
			BltEffect32_2000( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		case 2001:
			BltEffect32_2001( _sx, _sy, _sw, _sh, _dx, _dy, _ef, _op, _wf, _sc );
			break;
		default:
			BltFast( _sx, _sy, _sw, _sh, _dx, _dy );	
			break;
	}
}

/**********************************************************************
	GtFNgP pCと
**********************************************************************/
void CGraphicDriver::BltEffect32_01( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}

	//
	for( long j = _sh - 16; j >= 0; j -= 16 ){
		//
		if( _sc == -1 ){
			BltFast32( _sx, _sy + j, _sw, _sh - j, _dx, _dy  );
		}else{
			BltSprite32( _sx, _sy + j, _sw, _sh - j, _dx, _dy , _sc );
		}
		//
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op )Sleep( _op );
		else	 Sleep( 0 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	//
	BltFast32( _sx, _sy, _sw, _sh, _dx, _dy );
}

/**********************************************************************
	GtFNgQ pC
**********************************************************************/
void CGraphicDriver::BltEffect32_02( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}

	//
	for( long j = _sh - 16; j >= 0; j -= 16 ){
		//
		if( _sc == -1 ){
			BltFast32( _sx, _sy, _sw, _sh - j, _dx, _dy + j  );
		}else{
			BltSprite32( _sx, _sy, _sw, _sh - j, _dx, _dy + j , _sc );
		}
		//
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op )Sleep( _op );
		else	 Sleep( 0 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	//
	BltFast32( _sx, _sy, _sw, _sh, _dx, _dy );
}

/**********************************************************************
	GtFNgR PC΂㉺dˍ킹
**********************************************************************/
void CGraphicDriver::BltEffect32_03( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;

	long ylh , yrh;
	//
	for( long j = 0; j < _sh / 2 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		// ʒuړ
		ylh = j * 2;
		if( _sw % 2 ){ // 
			yrh = _sh - 2 - ( j * 2 );
		}else{
			yrh = _sh - 1 - ( j * 2 );
		}

		for( long i = 0; i < _sh; i++ ){
			if( i == ylh || i == yrh ){
				lpSrcPosWork  = lpSrcPos;
				lpDstPosWork  = lpDstPos;
				lpASrcPosWork = lpASrcPos;
				lpADstPosWork = lpADstPos;
				for( long x = 0; x < _sw; x++ ){
					if( _sc == -1 || *lpSrcPosWork != key ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}
					lpSrcPosWork++;	 lpDstPosWork++;
					lpASrcPosWork++; lpADstPosWork++;
				}
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy + ylh, _sw, 1 );
		OnDraw( _dx, _dy + yrh, _sw, 1 );
		// wait
		if( _op ){
			Sleep( _op );
		}else{
			if( j % 4 == 0 )Sleep( 1 );
		}
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
	
	// ȂŌɂ{
	BltFast32( _sx, _sy + _sh - 1, _sw, 1, _dx, _dy + _sh - 1 ); 
}

/**********************************************************************
	GtFNgS PC΂Edˍ킹
**********************************************************************/
void CGraphicDriver::BltEffect32_04( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
//	unsigned char *lpASrcPos;
//	unsigned char *lpADstPos;
	
	long xlh , xrh;
	stGrpRect rect;
	rect.top = _dy;
	rect.bottom = _dy + _sh;

	//
	for( long j = 0; j < _sw / 2 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
//		lpASrcPos= Bits.lpABits + sstart;
//		lpADstPos= Bits.lpABits + dstart;
		
		// ʒuړ
		xlh = j * 2;
		if( _sw % 2 ){ // 
			xrh = _sw - 2 - ( j * 2 );
		}else{
			xrh = _sw - 1 - ( j * 2 );
		}

		for( long i = 0; i < _sh; i++ ){
			// E
			if( _sc == -1 || lpSrcPos[xlh] != key ){
				lpDstPos[xlh] = lpSrcPos[xlh];
//				lpADstPos[xlh]= lpASrcPos[xlh];
			}
			// E
			if( _sc == -1 || lpSrcPos[xrh] != key ){
				lpDstPos[xrh] = lpSrcPos[xrh];
//				lpADstPos[xrh]= lpASrcPos[xrh];
			}		
			lpSrcPos += pitch; lpDstPos += pitch;
//			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		rect.left = _dx + xlh;
		rect.right= rect.left + 1;
		OnDraw( &rect );
		rect.left = _dx + xrh;
		rect.right= rect.left + 1;
		OnDraw( &rect );
		// wait
		if( _op ){
			Sleep( _op / 2);
		}else{
			if( j % 8 == 0 )Sleep( 1 );
		}
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();

	// ȂŌɂ{
	BltFast32( _sx + _sw - 1, _sy, 1, _sh, _dx + _sw - 1, _dy ); 
}

/**********************************************************************
	GtFNgT s͗liPUPU PUij
**********************************************************************/
void CGraphicDriver::BltEffect32_05( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}

	// W
	long cx[16] = {	 0, 32, 16, 48,  0, 32, 16, 48,
					16, 48,  0, 32, 16, 48,  0, 32 };
	long cy[16] = {  0,  0, 16, 16, 32, 32, 48, 48, 
					 0,  0, 16, 16, 32, 32, 48, 48 };

	//
	for( long j = 0; j < 16 ; j++ ){
		for( long y = 0; y < _sh ; y += 64 ){
			for( long x = 0; x < _sw ; x += 64 ){
				if( x + cx[j] + 16 <= _sw && y + cy[j] + 16<= _sh ){
					if( _sc == -1 ){
						BltFast32(	_sx + x + cx[j],
									_sy + y + cy[j],
									16, 16,
									_dx + x + cx[j],
									_dy + y + cy[j] ); 
					}else{
						BltSprite32(_sx + x + cx[j],
									_sy + y + cy[j],
									16, 16,
									_dx + x + cx[j],
									_dy + y + cy[j], _sc ); 
					}
				}
			}
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op ){
			Sleep( _op );
		}else{
			Sleep( 12 );
		}
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Ô
	if( _sc == -1 ){
		BltFast32(	_sx, _sy, _sw, _sh, _dx, _dy ); 
	}else{
		BltSprite32(_sx, _sy, _sw, _sh, _dx, _dy, _sc );
	}
}

/**********************************************************************
	GtFNgU R 킶SSiSij
**********************************************************************/
void CGraphicDriver::BltEffect32_06( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}

	// W
	long cx[4] = {	0, 4, 0, 4 };
	long cy[4] = {  0, 4, 4, 0 };

	//
	for( long j = 0; j < 4 ; j++ ){
		for( long y = 0; y < _sh ; y += 8 ){
			for( long x = 0; x < _sw ; x += 8 ){
				if( x + cx[j] + 4 <= _sw && y + cy[j] + 4 <= _sh ){
					if( _sc == -1 ){
						BltFast32(	_sx + x + cx[j],
									_sy + y + cy[j],
									4, 4,
									_dx + x + cx[j],
									_dy + y + cy[j] ); 
					}else{
						BltSprite32(_sx + x + cx[j],
									_sy + y + cy[j],
									4, 4,
									_dx + x + cx[j],
									_dy + y + cy[j], _sc ); 
					}
				}
			}
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op )Sleep( _op );
		else	 Sleep(  20);
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Ô
	if( _sc == -1 ){
		BltFast32(	_sx, _sy, _sw, _sh, _dx, _dy ); 
	}else{
		BltSprite32(_sx, _sy, _sw, _sh, _dx, _dy, _sc );
	}
}
/**********************************************************************
	GtFNgubgV O
**********************************************************************/
void CGraphicDriver::BltEffect32_07( long _sx, long _sy, long _sw, long _sh,
									long _dx, long _dy, long _ef, long _op,
									long _wf, long _sc )
{
	// RQiKɕiH
	const long div = 32;
	// n_-
	long sx = _sx;
	long sy = _sy;
	long sw = _sw;
	long sh = _sh;
	// I_
	long dx = _dx;
	long dy = _dy;
	
	long tx = (_sw / 2 - 1)/ div;
	long ty = (_sw / 2 - 1)/ div;
	
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// 
	for( long i = 0;i < div - 1;i++ ){
		if( _sc == -1 ){
			// 
			BltFast32( sx, sy, sw, ty, dx, dy ); 
			// E
			BltFast32( sx          , sy + ty, tx, sh - (ty*2), dx, dy + ty );
			BltFast32( sx + sw - tx, sy + ty, tx, sh - (ty*2), dx + sw - tx, dy + ty );
			// 
			BltFast32( sx, sy + sh - ty/* - 1*/, _sw, ty, dx, dy + sh - ty/* - 1*/ ); 
		}else{
			// 
			BltSprite32( sx, sy, sw, ty, dx, dy, _sc ); 
			// E
			BltSprite32( sx           , sy + ty, tx, sh - (ty*2), dx, dy + ty, _sc );
			BltSprite32( sx + sw - tx , sy + ty, tx, sh - (ty*2), dx + sw - tx, dy + ty, _sc );
			// 
			BltSprite32( sx, sy + sh - ty, _sw, ty, dx, dy + sh - ty, _sc ); 
		}
		OnDraw( dx, dy, sw, sh );
		// wait
		if( _op )	Sleep( _op );
		else		Sleep( 15 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}

		sx += tx;sy += ty;
		dx += tx;dy += ty;
		sw -= tx * 2;sh -= ty * 2;
	}
	if( _sc == -1 ){
		BltFast32( _sx, _sy, _sw, _sh, _dx, _dy );
	}else{
		BltSprite32( _sx, _sy, _sw, _sh, _dx, _dy, _sc );
	}
}

/**********************************************************************
	GtFNgubgW O
**********************************************************************/
void CGraphicDriver::BltEffect32_08( long _sx, long _sy, long _sw, long _sh,
									long _dx, long _dy, long _ef, long _op,
									long _wf, long _sc )
{
	// RQiKɕiH
	const long div = 32;
	// n_-
	long w2 = _sw / 2;
	long h2 = _sh / 2;
	long sx = w2 - 1 + _sx;
	long sy = h2 - 1 + _sy;
	long sw = 2;
	long sh = 2;
	// I_
	long dx = w2 - 1 + _dx;
	long dy = h2 - 1 + _dy;
	
	long tx = (w2 - 1)/ div;
	long ty = (h2 - 1)/ div;

	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// 
	for( long i = 0;i < div - 1;i++ ){
		if( _sc == -1 ){
			BltFast32( sx, sy, sw, sh, dx, dy );
		}else{
			BltSprite32( sx, sy, sw, sh, dx, dy, _sc );
		}
		OnDraw( dx, dy, sw, sh );
		// wait
		if( _op )	Sleep( _op );
		else		Sleep( 15 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}

		sx -= tx;sy -= ty;
		dx -= tx;dy -= ty;
		sw += tx * 2;sh += ty * 2;
	}
	if( _sc == -1 ){
		BltFast32( _sx, _sy, _sw, _sh, _dx, _dy );
	}else{
		BltSprite32( _sx, _sy, _sw, _sh, _dx, _dy, _sc );
	}
}

/**********************************************************************
	GtFNgX 킶SSiSij
**********************************************************************/
void CGraphicDriver::BltEffect32_09( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}

	// W
	long cx[4] = {	0, 4, 0, 4 };
	long cy[4] = {  0, 4, 4, 0 };

	//
	for( long j = 0; j < 4 ; j++ ){
		for( long y = 0; y < _sh ; y += 8 ){
			for( long x = 0; x < _sw ; x += 8 ){
				if( x + cx[j] + 4 <= _sw && y + cy[j] + 4 <= _sh ){
					if( _sc == -1 ){
						BltFast32(	_sx + x + cx[j],
									_sy + y + cy[j],
									4, 4,
									_dx + x + cx[j],
									_dy + y + cy[j] ); 
					}else{
						BltSprite32(_sx + x + cx[j],
									_sy + y + cy[j],
									4, 4,
									_dx + x + cx[j],
									_dy + y + cy[j], _sc ); 
					}
				}
			}
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op )Sleep( _op );
		else	 Sleep(  20);
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Ô
	if( _sc == -1 ){
		BltFast32(	_sx, _sy, _sw, _sh, _dx, _dy ); 
	}else{
		BltSprite32(_sx, _sy, _sw, _sh, _dx, _dy, _sc );
	}
}
/**********************************************************************
	GtFNgPP ꗎ
**********************************************************************/
void CGraphicDriver::BltEffect32_11( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	long work;
	//
	for( long j = 0; j < _sh / 16 + 15 ; j++ ){
		for( long y = 0; y < _sh; y += 16){
			work = j + 1 - y / 16;
			if( _sc == -1 && work <= 16 && work > 0 ){
				BltFast32(	_sx, _sy + y,
							_sw, work,
							_dx, _dy + y ); 
			}else{
				BltSprite32(_sx, _sy + y,
							_sw, work,
							_dx, _dy + y, _sc ); 
			}
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op )Sleep( _op );
		else	 Sleep( 30 );

		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}

	// Ô
	if( _sc == -1 ){
		BltFast32(	_sx, _sy, _sw, _sh, _dx, _dy ); 
	}else{
		BltSprite32(_sx, _sy, _sw, _sh, _dx, _dy, _sc );
	}
}

/**********************************************************************
	GtFNgPQ E
**********************************************************************/
void CGraphicDriver::BltEffect32_12( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	long x, i;
	//
	for( long j = 0; j < _sw-8; j+=8 ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		for( i = 0; i < _sh; i++ ){
			// 
			for( x = 0; x < 8;x++){
				if( _sc == -1 || lpSrcPos[j+x] != key ){
					lpDstPos[j+x] = lpSrcPos[j+x];
					lpADstPos[j+x]= lpASrcPos[j+x];
				}
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx + j, _dy, 8, _sh );
		// wait
		if( _op )	Sleep( _op );
		else		Sleep( 1 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();

	BltFast32( _sx, _sy, _sw, _sh, _dx, _dy );
}

/**********************************************************************
	GtFNgPR E
**********************************************************************/
void CGraphicDriver::BltEffect32_13( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	long x, i;
	//
	for( long j = _sw - 1; j >= 8 ; j -= 8 ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		for( i = 0; i < _sh; i++ ){
			// 
			for( x = 8;  x >= 0;x--){
				if( _sc == -1 || lpSrcPos[j-x] != key ){
					lpDstPos[j-x] = lpSrcPos[j-x];
					lpADstPos[j-x]= lpASrcPos[j-x];
				}
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx + j - 8, _dy, 8, _sh );
		// wait
		if( _op )	Sleep( _op );
		else		Sleep( 1 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();

	BltFast32( _sx, _sy, _sw, _sh, _dx, _dy );
}

/**********************************************************************
	GtFNgPS と
**********************************************************************/
void CGraphicDriver::BltEffect32_14( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;

	//
	for( long j = 0; j < _sh - 4; j += 4 ){
		lpSrcPos = Bits.lpCBits + sstart + pitch * j;
		lpDstPos = Bits.lpCBits + dstart + pitch * j;
		lpASrcPos= Bits.lpABits + sstart + pitch * j;
		lpADstPos= Bits.lpABits + dstart + pitch * j;
		
		for( long y = j; y < j + 4; y++ ){
			// 
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;
			 
			for( long x = 0; x < _sw; x++ ){
				if( _sc == -1 || *lpSrcPosWork != key ){
					*lpDstPosWork = *lpSrcPosWork;
					*lpADstPosWork= *lpASrcPosWork;
				}
				lpSrcPosWork++;	 lpDstPosWork++;
				lpASrcPosWork++; lpADstPosWork++;
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy + j, _sw, 4 );
		// wait
		if( _op )	Sleep( _op );
		else		Sleep( 1 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
	BltFast32( _sx, _sy, _sw, _sh, _dx, _dy );
}

/**********************************************************************
	GtFNgPU cCL
**********************************************************************/
void CGraphicDriver::BltEffect32_16( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;

	//
	for( long j = 0; j < 16 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		for( long i = 0; i < _sh; i++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;

			for( long x = 0; x < _sw; x++ ){
				if( (x % 16) == j ){
					if( _sc == -1 || *lpSrcPosWork != key ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}
				}
				lpSrcPosWork++;	 lpDstPosWork++;
				lpASrcPosWork++; lpADstPosWork++;
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op )Sleep( _op );
		else	 Sleep( 20 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}

	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	GtFNgPV CL
**********************************************************************/
void CGraphicDriver::BltEffect32_17( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;

	//
	for( long j = 0; j < 16 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		for( long i = 0; i < _sh; i++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;

			if( (i % 16) == j ){
				for( long x = 0; x < _sw; x++ ){
					if( _sc == -1 || *lpSrcPosWork != key ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}
					lpSrcPosWork++;	 lpDstPosWork++;
					lpASrcPosWork++; lpADstPosWork++;
				}
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		Sleep( _op );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}

	// Unlock
	m_lpScreen->Unlock();
}


/**********************************************************************
	GtFNgPW cCO
**********************************************************************/
void CGraphicDriver::BltEffect32_18( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	long xlh = _sw / 2, xrh = _sw / 2 - 1;
	//
	for( long j = 0; j < _sw / 2 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		// ʒuړ
		xlh--;
		xrh++;

		for( long i = 0; i < _sh; i++ ){
			// E
			if( _sc == -1 || lpSrcPos[xlh] != key ){
				lpDstPos[xlh] = lpSrcPos[xlh];
				lpADstPos[xlh]= lpASrcPos[xlh];
			}
			// E
			if( _sc == -1 || lpSrcPos[xrh] != key ){
				lpDstPos[xrh] = lpSrcPos[xrh];
				lpADstPos[xrh]= lpASrcPos[xrh];
			}		
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx + xlh, _dy, 1, _sh );
		OnDraw( _dx + xrh, _dy, 1, _sh );
		// wait
		if( j % 4 == 0 ){
			if( _op )	Sleep( _op );
			else		Sleep( 1 );
		}
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();

	// ȂŌɂ{
	BltFast32( xrh+1, _sy, 1, _sh, _dx + xrh + 1, _dy ); 
}

/**********************************************************************
	GtFNgPX cCO
**********************************************************************/
void CGraphicDriver::BltEffect32_19( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	long xlh = -1, xrh = _sw;
	//
	for( long j = 0; j < _sw / 2 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		// ʒuړ
		xlh++;
		xrh--;

		for( long i = 0; i < _sh; i++ ){
			// E
			if( _sc == -1 || lpSrcPos[xlh] != key ){
				lpDstPos[xlh] = lpSrcPos[xlh];
				lpADstPos[xlh]= lpASrcPos[xlh];
			}
			// E
			if( _sc == -1 || lpSrcPos[xrh] != key ){
				lpDstPos[xrh] = lpSrcPos[xrh];
				lpADstPos[xrh]= lpASrcPos[xrh];
			}		
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx + xlh, _dy, 1, _sh );
		OnDraw( _dx + xrh, _dy, 1, _sh );
		// wait
		if( j % 4 == 0 ){
			if( _op )	Sleep( _op );
			else		Sleep( 1 );
		}
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();

	// Ȃ^񒆂ɂ{
	BltFast32( xlh+1, _sy, 1, _sh, _dx + xlh + 1, _dy ); 

}

/**********************************************************************
	GtFNgQO CAO
**********************************************************************/
void CGraphicDriver::BltEffect32_20( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;

	long ylh = _sh / 2, yrh = _sh / 2 - 1;
	//
	for( long j = 0; j < _sh / 2 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		ylh--;
		yrh++;

		for( long i = 0; i < _sh; i++ ){
			if( i == ylh || i == yrh ){
				lpSrcPosWork  = lpSrcPos;
				lpDstPosWork  = lpDstPos;
				lpASrcPosWork = lpASrcPos;
				lpADstPosWork = lpADstPos;
				for( long x = 0; x < _sw; x++ ){
					if( _sc == -1 || *lpSrcPosWork != key ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}
					lpSrcPosWork++;	 lpDstPosWork++;
					lpASrcPosWork++; lpADstPosWork++;
				}
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy + ylh, _sw, 1 );
		OnDraw( _dx, _dy + yrh, _sw, 1 );
		// wait
		if( j % 4 == 0 ){
			if( _op )	Sleep( _op );
			else		Sleep( 1 );
		}
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
	
	// ȂŌɂ{
	BltFast32( _sx, yrh+1, _sw, 1, _dx, _dy + yrh + 1 ); 
}

/**********************************************************************
	GtFNgQP CAO
**********************************************************************/
void CGraphicDriver::BltEffect32_21( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;

	long ylh = -1, yrh = _sh;
	//
	for( long j = 0; j < _sh / 2 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		
		ylh++;
		yrh--;

		for( long i = 0; i < _sh; i++ ){
			if( i == ylh || i == yrh ){
				lpSrcPosWork  = lpSrcPos;
				lpDstPosWork  = lpDstPos;
				lpASrcPosWork = lpASrcPos;
				lpADstPosWork = lpADstPos;
				for( long x = 0; x < _sw; x++ ){
					if( _sc == -1 || *lpSrcPosWork != key ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}
					lpSrcPosWork++;	 lpDstPosWork++;
					lpASrcPosWork++; lpADstPosWork++;
				}
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy + ylh, _sw, 1 );
		OnDraw( _dx, _dy + yrh, _sw, 1 );
		// wait
		if( j % 4 == 0 ){
			if( _op )	Sleep( _op );
			else		Sleep( 1 );
		}
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
	
	// Ȃ^񒆂ɂ{
	BltFast32( _sx, ylh+1, _sw, 1, _dx, _dy + ylh + 1 ); 
}

/**********************************************************************
	GtFNgQQ 킶QQiQij
**********************************************************************/
void CGraphicDriver::BltEffect32_22( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	//
	for( long j = 0; j < 2 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		for( long y = 0; y < _sh; y ++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;
			if( j == 0 ){
				for( long x = 0; x < _sw; x++ ){
					if( _sc == -1 || *lpSrcPosWork != key ){
						if( ( ((y/2) % 2) &&  ((x/2) % 2)) ||
							(!((y/2) % 2) && !((x/2) % 2)) ){
							*lpDstPosWork = *lpSrcPosWork;
							*lpADstPosWork= *lpASrcPosWork;
						}
					}
					lpSrcPosWork++;	 lpDstPosWork++;
					lpASrcPosWork++; lpADstPosWork++;
				}
			}else{
				for( long x = 0; x < _sw; x++ ){
					if( _sc == -1 || *lpSrcPosWork != key ){
						if( ( !((y/2) % 2) &&  ((x/2) % 2)) ||
							(  ((y/2) % 2) && !((x/2) % 2)) ){
							*lpDstPosWork = *lpSrcPosWork;
							*lpADstPosWork= *lpASrcPosWork;
						}
					}
					lpSrcPosWork++;	 lpDstPosWork++;
					lpASrcPosWork++; lpADstPosWork++;
				}
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op )Sleep( _op );
		else	 Sleep(  20 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	GtFNgQR 킶QQiSij
**********************************************************************/
void CGraphicDriver::BltEffect32_23( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	//
	for( long j = 0; j < 4 ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		for( long y = 0; y < _sh; y ++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;
			for( long x = 0; x < _sw; x++ ){
				if( _sc == -1 || *lpSrcPosWork != key ){
					if( j == 0 && ((y/2) % 2) &&  ((x/2) % 2) ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}else if( j == 1 && !((y/2) % 2) && !((x/2) % 2) ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}else if( j == 2 && !((y/2) % 2) && ((x/2) % 2) ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}else if( j == 3 && ((y/2) % 2) && !((x/2) % 2) ){
						*lpDstPosWork = *lpSrcPosWork;
						*lpADstPosWork= *lpASrcPosWork;
					}
				}
				lpSrcPosWork++;	 lpDstPosWork++;
				lpASrcPosWork++; lpADstPosWork++;
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		if( _op )Sleep( _op );
		else	 Sleep(  20 );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	GtFNgQV tF[hC
**********************************************************************/
void CGraphicDriver::BltEffect32_27( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();
	// 
	const long div = ALSD_ABTABLE_DEPTH;
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	bool bFlag = false;
	long sr, sg, sb; // src_rgb
	//
	for( long j = 0; j < div ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		for( long i = 0; i < _sh; i++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;
			for( long x = 0; x < _sw; x++ ){
				if( _sc == -1 || *lpSrcPosWork != key ){
					sr = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
					sg = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
					sb = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwBBitMask);
					if( !bFlag && ( sr || sg || sb ) )bFlag = true;
	
					sr = m_AlphaBlendTable[j][sr];
					sg = m_AlphaBlendTable[j][sg];
					sb = m_AlphaBlendTable[j][sb];
					
					*lpDstPosWork = sr << 16 | sg << 8 | sb ;
					*lpADstPosWork= *lpASrcPosWork;
				}
				lpSrcPosWork++;	 lpDstPosWork++;
				lpASrcPosWork++; lpADstPosWork++;
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		Sleep( _op );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
		if( bFlag == false )break;
	}
	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	GtFNgQW zCgC
**********************************************************************/
void CGraphicDriver::BltEffect32_28( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// 
	const long div = ALSD_ABTABLE_DEPTH;
	long add = 256;
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	long sr, sg, sb; // src_rgb
	//
	for( long j = 0; j < div + 1; j++){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		for( long i = 0; i < _sh; i++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;
			for( long x = 0; x < _sw; x++ ){
				if( _sc == -1 || *lpSrcPosWork != key ){
					sr = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
					sg = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
					sb = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwBBitMask);
	
					sr = sr + add;
					if( sr > 255 )sr = 255;
					sg = sg + add;
					if( sg > 255 )sg = 255;
					sb = sb + add;
					if( sb > 255 )sb = 255;
					
					*lpDstPosWork = sr << 16 | sg << 8 | sb ;
					*lpADstPosWork= *lpASrcPosWork;
				}
				lpSrcPosWork++;	 lpDstPosWork++;
				lpASrcPosWork++; lpADstPosWork++;
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		//
		add -= 256/div;
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		Sleep( _op );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();

}

/**********************************************************************
	GtFNgQX tF[hAEg
**********************************************************************/
void CGraphicDriver::BltEffect32_29( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
//	unsigned long time, time2;
//	GetTickCount( &time );
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// 
	const long div = ALSD_ABTABLE_DEPTH;
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	long sr, sg, sb; // src_rgb
	//
	for( long j = div - 1; j >= 0 ; j-- ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		for( long i = 0; i < _sh; i++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;
			for( long x = 0; x < _sw; x++ ){
				if( _sc == -1 || *lpSrcPosWork != key ){
					sr = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
					sg = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
					sb = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwBBitMask);
	
					sr = m_AlphaBlendTable[j][sr];
					sg = m_AlphaBlendTable[j][sg];
					sb = m_AlphaBlendTable[j][sb];
					
					*lpDstPosWork = sr << 16 | sg << 8 | sb ;
					*lpADstPosWork= *lpASrcPosWork;
				}
				lpSrcPosWork++;	 lpDstPosWork++;
				lpASrcPosWork++; lpADstPosWork++;
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		Sleep( _op );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
//	GetTickCount( &time2 );
//	time = time2 - time;
}

/**********************************************************************
	GtFNgRO zCgAEg
**********************************************************************/
void CGraphicDriver::BltEffect32_30( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// 
	const long div = ALSD_ABTABLE_DEPTH;
//	const long div = 128;
	long add = 0;
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	long sr, sg, sb; // src_rgb
	//
	for( long j = 0; j < div + 1; j++){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		for( long i = 0; i < _sh; i++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;
			for( long x = 0; x < _sw; x++ ){
				if( _sc == -1 || *lpSrcPosWork != key ){
					sr = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
					sg = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
					sb = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwBBitMask);
	
					sr = sr + add;
					if( sr > 255 )sr = 255;
					sg = sg + add;
					if( sg > 255 )sg = 255;
					sb = sb + add;
					if( sb > 255 )sb = 255;
					
					*lpDstPosWork = sr << 16 | sg << 8 | sb ;
					*lpADstPosWork= *lpASrcPosWork;
				}
				lpSrcPosWork++;	 lpDstPosWork++;
				lpASrcPosWork++; lpADstPosWork++;
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		//
		add += 256/div;
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		Sleep( _op );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
}
/**********************************************************************
	GtFNgRP NXtF[h
**********************************************************************/
void CGraphicDriver::BltEffect32_31( long _sx, long _sy, long _sw, long _sh,
									 long _dx, long _dy, long _ef, long _op,
									 long _wf, long _sc )
{
	//
	long *rnd = m_lpSD->GetExpDriver()->GetSystemVar();
	CCommandDriver *lpCD = m_lpSD->GetCmdDriver();

	// 
	const long div = ALSD_ABTABLE_DEPTH;
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	// ʒu
	long pitch = Desc.lPitch / 4;
	long sstart= _sx + _sy * pitch;
	long dstart= _dx + _dy * pitch;
	unsigned long *lpSrcPos;
	unsigned long *lpDstPos;
	unsigned char *lpASrcPos;
	unsigned char *lpADstPos;
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	long sr, sg, sb; // src_rgb
	long dr, dg, db; // dst_rgb
	//
	for( long j = 0; j < div ; j++ ){
		lpSrcPos = Bits.lpCBits + sstart;
		lpDstPos = Bits.lpCBits + dstart;
		lpASrcPos= Bits.lpABits + sstart;
		lpADstPos= Bits.lpABits + dstart;
		for( long i = 0; i < _sh; i++ ){
			lpSrcPosWork  = lpSrcPos;
			lpDstPosWork  = lpDstPos;
			lpASrcPosWork = lpASrcPos;
			lpADstPosWork = lpADstPos;
			for( long x = 0; x < _sw; x++ ){
				if( _sc == -1 || *lpSrcPosWork != key ){
					sr = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
					sg = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
					sb = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwBBitMask);
					
					dr = (*lpDstPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
					dg = (*lpDstPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
					db = (*lpDstPosWork & Desc.dgpfPixelFormat.dwBBitMask);
	
					sr = (long)m_AlphaBlendTable[j][sr] + (long)m_AlphaBlendTable[div-j-1][dr];
					sg = (long)m_AlphaBlendTable[j][sg] + (long)m_AlphaBlendTable[div-j-1][dg];
					sb = (long)m_AlphaBlendTable[j][sb] + (long)m_AlphaBlendTable[div-j-1][db];
					
					if(sr > 255)sr = 255;
					if(sg > 255)sg = 255;
					if(sb > 255)sb = 255;

					*lpDstPosWork = sr << 16 | sg << 8 | sb ;
					*lpADstPosWork= *lpASrcPosWork;
				}
				lpSrcPosWork++;	 lpDstPosWork++;
				lpASrcPosWork++; lpADstPosWork++;
			}
			lpSrcPos += pitch; lpDstPos += pitch;
			lpASrcPos+= pitch; lpADstPos+= pitch;
		}
		OnDraw( _dx, _dy, _sw, _sh );
		// wait
		Sleep( _op );
		// keytO
		if( _wf ){
			*rnd = lpCD->CommandIK6_Sub();
			if( *rnd )break;
		}
	}
	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	xw
**********************************************************************/
void CGraphicDriver::BltEffect32_2000(	long _sx, long _sy, long _sw, long _sh,
										long _dx, long _dy, long _ef, long _op,
										long _wf, long _sc )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	long rate = _op >> ALSD_ABTABLE_BITS;

	// ʒu
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = Bits.lpCBits;
	lpSrcPos += ( _sx + _sy * pitch );
	unsigned long *lpDstPos = Bits.lpCBits;
	lpDstPos += ( _dx + _dy * pitch );
	unsigned char *lpASrcPos =Bits.lpABits;
	lpASrcPos +=( _sx + _sy * pitch );
	unsigned char *lpADstPos =Bits.lpABits;
	lpADstPos +=( _dx + _dy * pitch );
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	long sr, sg, sb;
	//
	for( long i = 0; i < _sh; i++ ){
		lpSrcPosWork  = lpSrcPos;
		lpDstPosWork  = lpDstPos;
		lpASrcPosWork = lpASrcPos;
		lpADstPosWork = lpADstPos;
		for( long x = 0; x < _sw; x++ ){
			if( _sc == -1 || *lpSrcPosWork != key ){
				sr = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
				sg = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
				sb = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwBBitMask);

				sr = m_AlphaBlendTable[rate][sr];
				sg = m_AlphaBlendTable[rate][sg];
				sb = m_AlphaBlendTable[rate][sb];

				*lpDstPosWork = sr << 16 | sg << 8 | sb ;
				*lpADstPosWork= *lpASrcPosWork;
			}
			lpSrcPosWork++;
			lpDstPosWork++;
			lpASrcPosWork++;
			lpADstPosWork++;
		}
		lpSrcPos += pitch;
		lpDstPos += pitch;
		lpASrcPos+= pitch;
		lpADstPos+= pitch;
	}

	// Unlock
	m_lpScreen->Unlock();
}

/**********************************************************************
	ߎw
**********************************************************************/
void CGraphicDriver::BltEffect32_2001(	long _sx, long _sy, long _sw, long _sh,
										long _dx, long _dy, long _ef, long _op,
										long _wf, long _sc )
{
	stGrpScreenBits Bits;
	stGrpScreenDesc Desc;
	// bN
	if( !m_lpScreen->Lock( &Bits, &Desc ) )return;

	// J[L[
	unsigned long key = 0;
	if( _sc != -1 ){
		key =	( (long)m_Palette.entry[_sc].red  << 16 ) |
				( (long)m_Palette.entry[_sc].green<<  8 ) |
				( (long)m_Palette.entry[_sc].blue	   );
	}
	long srate = _op >> ALSD_ABTABLE_BITS;
	long drate = (255 - _op) >> ALSD_ABTABLE_BITS;

	// ʒu
	long pitch = Desc.lPitch / 4;
	unsigned long *lpSrcPos = Bits.lpCBits;
	lpSrcPos += ( _sx + _sy * pitch );
	unsigned long *lpDstPos = Bits.lpCBits;
	lpDstPos += ( _dx + _dy * pitch );
	unsigned char *lpASrcPos =Bits.lpABits;
	lpASrcPos +=( _sx + _sy * pitch );
	unsigned char *lpADstPos =Bits.lpABits;
	lpADstPos +=( _dx + _dy * pitch );
	
	unsigned long *lpSrcPosWork;
	unsigned long *lpDstPosWork;
	unsigned char *lpASrcPosWork;
	unsigned char *lpADstPosWork;
	
	long sr, sg, sb;
	long dr, dg, db;
	//
	for( long i = 0; i < _sh; i++ ){
		lpSrcPosWork  = lpSrcPos;
		lpDstPosWork  = lpDstPos;
		lpASrcPosWork = lpASrcPos;
		lpADstPosWork = lpADstPos;
		for( long x = 0; x < _sw; x++ ){
			if( _sc == -1 || *lpSrcPosWork != key ){
				sr = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
				sg = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
				sb = (*lpSrcPosWork & Desc.dgpfPixelFormat.dwBBitMask);

				dr = (*lpDstPosWork & Desc.dgpfPixelFormat.dwRBitMask) >> 16;
				dg = (*lpDstPosWork & Desc.dgpfPixelFormat.dwGBitMask) >>  8;
				db = (*lpDstPosWork & Desc.dgpfPixelFormat.dwBBitMask);

				sr = m_AlphaBlendTable[srate][sr] + m_AlphaBlendTable[drate][dr];
				if( sr > 255 )sr = 255;
				sg = m_AlphaBlendTable[srate][sg] + m_AlphaBlendTable[drate][dg];
				if( sg > 255 )sg = 255;
				sb = m_AlphaBlendTable[srate][sb] + m_AlphaBlendTable[drate][db];
				if( sb > 255 )sb = 255;

				*lpDstPosWork = sr << 16 | sg << 8 | sb ;
				*lpADstPosWork= *lpASrcPosWork;
			}
			lpSrcPosWork++;
			lpDstPosWork++;
			lpASrcPosWork++;
			lpADstPosWork++;
		}
		lpSrcPos += pitch;
		lpDstPos += pitch;
		lpASrcPos+= pitch;
		lpADstPos+= pitch;
	}

	// Unlock
	m_lpScreen->Unlock();
}
