/*
 * GraphicDriver_BeOS.cpp 
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "GraphicDriver_BeOS.h"

#include "UTF8.h"
#include "OffScreen_BeOS.h"
#include "MainFrame.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_BeOS;
using namespace App;
#endif
/**********************************************************************
	RXgNV
**********************************************************************/
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
CGraphicDriver_BeOS::CGraphicDriver_BeOS( ALSD::CScenarioDecoder *_lpScenarioDecoder )
#else
CGraphicDriver_BeOS::CGraphicDriver_BeOS( CScenarioDecoder *_lpScenarioDecoder )
#endif
: CGraphicDriver( _lpScenarioDecoder )
{
	m_lpMainFrame = NULL;
//	m_lpView	  = NULL;

	m_lpScreen = new COffScreen_BeOS();
	m_lpScreen->Create( 640, 480, 32 );
	ClearAlpha( 0xFF );
	ClearColor( 0x00000000 );
}

CGraphicDriver_BeOS::~CGraphicDriver_BeOS()
{
	if( m_lpScreen )delete m_lpScreen;
}

/**********************************************************************
	ŗL̐ݒ
**********************************************************************/
void CGraphicDriver_BeOS::SetLocalInfo( void *_lpInfo )
{
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	m_lpMainFrame = (App::CMainFrame *)_lpInfo;
#else
	m_lpMainFrame = (CMainFrame *)_lpInfo;
#endif
//	m_lpView	  = m_lpMainFrame->ChildAt(0);
}

/**********************************************************************
	OnDrawnh
**********************************************************************/
void CGraphicDriver_BeOS::OnDraw( stGrpRect *_lpUpdateRect )
{
	// Abvf[g\ȂItXN[] 
	if( m_bUpdate ){
		//
		if( m_lpMainFrame->Lock() ){
			BView *lpView = m_lpMainFrame->ChildAt(1);
			m_lpScreen->UpdateView( _lpUpdateRect, (void *)lpView );
			m_lpMainFrame->Unlock();
			m_lpMainFrame->Flush();
		}
	}
}

/**********************************************************************
	r[TCY
**********************************************************************/
void CGraphicDriver_BeOS::SetViewSize( long _start_x, long _start_y,
									    long _size_x , long _size_y )
{
	m_lpScreen->CreateView( _size_x, _size_y );
	
	//
	m_ViewRect.left = _start_x;
	m_ViewRect.top  = _start_y;
	m_ViewRect.right= _start_x + _size_x;
	m_ViewRect.bottom=_start_y + _size_y;
	m_ViewC = 32;
	
	// CEBhẼTCYύX
	BRect rect(0, 0, _size_x, _size_y );
	m_lpMainFrame->AdjustWindow( &rect );

	m_lpMainFrame->ResizeTo( rect.right, rect.bottom );
}

/**********************************************************************
	Window̃^Cgݒ肷
**********************************************************************/
void CGraphicDriver_BeOS::SetWindowTitle( const char *_lpTitle )
{
	char *lpTitleUTF8 = new char[(strlen( _lpTitle ) + 1) * 3];
	
	int32 srcLen = strlen( _lpTitle ) + 1;
	int32 dstLen = (strlen( _lpTitle ) + 1) * 3;
	int32 state  = 0;
	
	::convert_to_utf8( 	  B_SJIS_CONVERSION, _lpTitle,&srcLen,
						lpTitleUTF8,&dstLen, &state );
	
	m_lpMainFrame->SetTitle( lpTitleUTF8 );

	delete[] lpTitleUTF8;
}

/**********************************************************************
	}EXJ[\𓮂
**********************************************************************/
void CGraphicDriver_BeOS::SetMousePos( long _x, long _y )
{
}

/**********************************************************************
	bZ[W𗬂
**********************************************************************/
void CGraphicDriver_BeOS::PumpMessage( void )
{
}

/**********************************************************************
	XbhԎ~߂
**********************************************************************/
void CGraphicDriver_BeOS::Sleep( unsigned long Milliseconds )
{
	static long count = 0;
	if( count > 5 ){
		count = 0;
		PumpMessage();
	}
	count++;
	::snooze( Milliseconds * 1000 );
}

/*************************************************************************
*************************************************************************/
void CGraphicDriver_BeOS::GetTickCount( unsigned long *_Milliseconds )
{
	uint64 now = system_time();
	now /= 1000;
	*_Milliseconds = now;
}

