/*
 * GraphicDriver_BeOS.h
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */
#ifndef __GraphicDriver_BeOS_h__
#define __GraphicDriver_BeOS_h__
/**********************************************************************
	scenario decoder system BeOS
**********************************************************************/
#include "ScenarioDecoderSystem.h"
#include "GraphicDriver.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD_BeOS {
#endif
	class CGraphicDriver_BeOS;
	class COffScreen_BeOS;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace App{
#endif
	class CMainFrame;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

//
// class
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class ALSD_BeOS::CGraphicDriver_BeOS : public ALSD::CGraphicDriver {
#else
class CGraphicDriver_BeOS : public CGraphicDriver {
#endif
public:
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	CGraphicDriver_BeOS( ALSD::CScenarioDecoder *_lpScenarioDecoder );
#else
	CGraphicDriver_BeOS( CScenarioDecoder *_lpScenarioDecoder );
#endif
	virtual ~CGraphicDriver_BeOS();

	// system function(ms)
	virtual void Sleep( unsigned long Milliseconds );
	virtual void GetTickCount( unsigned long *_Milliseconds );
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	virtual void GetSystemName( std::string &_str ){_str = "BeOS R4";};
#else
	virtual void GetSystemName( string &_str ){_str = "BeOS R4";};
#endif
	virtual void PumpMessage( void );

	// interface implement
	virtual void OnDraw( stGrpRect *_lpUpdateRect );
	virtual void SetLocalInfo( void *_lpInfo );
	virtual void SetViewSize( long _start_x, long _start_y, long _size_x, long _size_y );
	virtual void SetWindowTitle( const char *_lpTitle );
	virtual void SetMousePos( long _x, long _y );
	virtual void ExitSystem( void ){};

protected:
//	BView *m_lpView;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	App::CMainFrame *m_lpMainFrame;
#else
	CMainFrame *m_lpMainFrame;
#endif
private:
};

#endif
