/*
 * GraphicDriver_WIN32.h
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __GraphicDriver_WIN32_h__
#define __GraphicDriver_WIN32_h__
/**********************************************************************
	scenario decoder system WIN32
**********************************************************************/
#include "ScenarioDecoderSystem.h"
#include "GraphicDriver.h"
#define STRICT 1
#include <windows.h>

namespace ALSD_WIN32 {
	class CGraphicDriver_WIN32;
	class COffScreen_WIN32;
};
//
// class
class ALSD_WIN32::CGraphicDriver_WIN32 : public ALSD::CGraphicDriver {
public:
	CGraphicDriver_WIN32( ALSD::CScenarioDecoder *_lpScenarioDecoder );
	virtual ~CGraphicDriver_WIN32();

	// system function
	virtual void Sleep( unsigned long Milliseconds );
	virtual void GetTickCount( unsigned long *_Milliseconds ){ *_Milliseconds = ::GetTickCount();};
	virtual void GetSystemName( std::string &_str ){_str = "Microsoft Win32";};
	virtual void PumpMessage( void );

	// interface implement
	virtual void OnDraw( stGrpRect *_lpUpdateRect );
	virtual void SetLocalInfo( void *_lpInfo ){ m_hWnd = *(HWND *)_lpInfo;}
	virtual void SetViewSize( long _start_x, long _start_y, long _size_x, long _size_y );
	virtual void SetWindowTitle( const char *_lpTitle );
	virtual void SetMousePos( long _x, long _y );
	virtual void ExitSystem( void );

protected:
	HWND	m_hWnd;
private:
};

#endif
