/*
 * hankaku.cpp - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "Kanakan.h"

#define HANZENTBL_COUNT 23

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace std;
#endif

static unsigned char tbl[HANZENTBL_COUNT][4] = 
{
	{ "i" "(" }, // 1
	{ "j" ")" },
	{ "@" " " },
	{ "" "=" },
	{ "[" "-" }, // 5
	{ "|" "-" },
	{ "A" "," },
	{ "C" "," },
	{ "" "<" },
	{ "" ">" }, //10
	{ "{" "+" },
	{ "" "*" },
	{ "" "@" },
	{ "o" "{" }, //15
	{ "p" "}" },
	{ "I" "!" },
	{ "" "#" },
	{ "" "$" },
	{ "" "%" }, //20 
	{ "" "&" },
	{ "D" "." },
	{ "^" "/" },
};

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
string kanakan::zentohan2(const unsigned char *src)
#else
string zentohan2(const unsigned char *src)
#endif
{
	// ApH
	string str;
	
	int c0, c1;
	
	while( *src ){
		c0 = *src++;
		if( c0 == 0x82 ){
			c1 = *src++;
			if( c1  >= 0x4f && c1 <= 0x58 ){		// Spl
				str += c1 - 0x4f + 0x30;
			}else if( c1 >= 0x60 && c1 <= 0x79 ){	// 啶
				str += c1 - 0x60 + 0x41;
			}else if( c1 >= 0x81 && c1 <= 0x9a ){
				str += c1 - 0x81 + 0x61;
			}else{
				str += c0;
				str += c1;
			}
		}else if( c0 >= 0x81 && c0 <= 0x9f ||
			c0 >= 0xe0 && c0 <= 0xfc ){
			//
			c1 = *src++;
			int i;
			for( i = 0;i < HANZENTBL_COUNT;i++ ){
				if( tbl[i][0] == c0 && tbl[i][1] == c1 ){
					str += tbl[i][2];
					break;
				}
			}
			if( i == HANZENTBL_COUNT ){		
				// ϊłȂQoCg
				str += c0;
				str += c1;
			}
		}else{
			str += c0;
		}
	}

	return str;
}
