/*
 * OffScreen.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __OffScreen_h__
#define __OffScreen_h__
/**********************************************************************
	scenario decoder system offscreen interface
**********************************************************************/
#include "ScenarioDecoderSystem.h"

#ifndef WIDTHBYTES
	#define WIDTHBYTES(bits)    (((bits) + 31) / 32 * 4)
#endif

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD {
#endif
	class COffScreen;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD_OFFSCR {
#endif
	struct stGrpPixelFormat {
		unsigned long dwSize;			// \̂̃TCY
		unsigned long dwRGBABitCount;	// 8, 16, 32
		unsigned long dwRBitMask;		// rbg}XN
		unsigned long dwGBitMask;
		unsigned long dwBBitMask;
		unsigned long dwABitMask;
	};

	struct stGrpScreenDesc {
		unsigned long		dwSize;		// \̂̃TCY
		unsigned long		dwHeight;
		unsigned long		dwWidth;
		long				lPitch;
		stGrpPixelFormat	dgpfPixelFormat;// sNZtH[}bg
		unsigned long		dwCaps;
	};

	struct stGrpScreenBits {
		unsigned long *lpCBits;
		unsigned char *lpABits;
		unsigned long *lpBackupCBits;
		unsigned char *lpBackupABits;
	};
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif
//
// class
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class ALSD::COffScreen {
#else
class COffScreen {
#endif
public:
	//
	COffScreen(){ m_Fade = 0;};
	virtual ~COffScreen(){};

	// interface
	virtual void Create( long _w, long _h, long _bpp ) = 0;
	virtual void Destroy(void ) = 0;
	virtual void CreateView( long _w, long _h ) = 0;
	virtual void DestroyView( void ) = 0;
	virtual void UpdateView( stGrpRect *_lpRect, void *_lpInfo ) = 0;

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	virtual bool Lock( ALSD_OFFSCR::stGrpScreenBits *_lpBits, ALSD_OFFSCR::stGrpScreenDesc *_lpDesc ) = 0;
#else
	virtual bool Lock( stGrpScreenBits *_lpBits, stGrpScreenDesc *_lpDesc ) = 0;
#endif
	virtual bool Unlock(void) = 0;

	// 
	virtual void FillRect	( long _x, long _y, long _w, long _h, unsigned long _rgb32 ) = 0;
	virtual void StrokeRect	( long _x, long _y, long _w, long _h, unsigned long _rgb32 ) = 0;
	virtual void StrokeLine	( long _x1,long _y1,long _x2,long _y2,unsigned long _rgb32 ) = 0;
	virtual void SetFontSize( long _size ) = 0;
	virtual long GetFontSize( void ) = 0;
	virtual void SetFont	( long _num ) = 0;
	virtual void SetFontWeight( long _w ){};
	virtual void DrawString	( long _x, long _y, const char *_lpString, unsigned long _rgb32 ) = 0;
	
	//
	void SetFade( long _Fade ){ m_Fade = _Fade;};
protected:
	//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
	ALSD_OFFSCR::stGrpScreenDesc	m_Desc;
#else
	stGrpScreenDesc	m_Desc;
#endif
	
	// tF[h
	long	m_Fade; // ȂÂAȂzCgtF[h
	void	DrawFade( void *_lpBits, stGrpRect *_lpRect ); // tF[hViewBitmapɕ`
	long	m_ViewX;
	long	m_ViewY;
private:
};

#endif
