/*
 * OffScreen.cpp - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "OffScreen.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_OFFSCR;
#endif
/**********************************************************************
	ubNtF[h
**********************************************************************/
void COffScreen::DrawFade( void *_lpBits, stGrpRect *_lpRect )
{
	long sr, sg, sb;

	long sx, sy, sw, sh;

	sx = _lpRect->left;
	sy = _lpRect->top;
	sw = _lpRect->right - _lpRect->left;
	sh = _lpRect->bottom- _lpRect->top;

	if( sx > m_ViewX )return;
	if( sy > m_ViewY )return;
	if( sx < 0 )sx = m_ViewX;
	if( sy < 0 )sy = m_ViewY;
	if( sw + sx > m_ViewX )sw = m_ViewX - sx;
	if( sh + sy > m_ViewY )sh = m_ViewY - sy;

	// n_
	long pitch = m_ViewX;
	unsigned long	*lpSrcPos = (unsigned long *)_lpBits;
	lpSrcPos += (sx + sy * pitch);
	
	unsigned long *lpSrcWork;
	for( long y = 0; y < sh; y++ ){
		lpSrcWork = lpSrcPos;
		for( long x = 0; x < sw; x++ ){
			// \[X
			sr = ((*lpSrcWork & m_Desc.dgpfPixelFormat.dwRBitMask) >> 16);
			sg = ((*lpSrcWork & m_Desc.dgpfPixelFormat.dwGBitMask) >>  8);
			sb = ((*lpSrcWork & m_Desc.dgpfPixelFormat.dwBBitMask)      );
			// Z
			sr -= m_Fade;
			if( sr < 0 )sr = 0;
			if( sr > 255 )sr = 255;
			sg -= m_Fade;
			if( sg < 0 )sg = 0;
			if( sg > 255 )sg = 255;
			sb -= m_Fade;
			if( sb < 0 )sb = 0;
			if( sb > 255 )sb = 255;
			// 
			*lpSrcWork = (sr << 16) | (sg << 8) | sb;
			lpSrcWork++;
		}
		lpSrcPos += pitch;
	}
}
