/*
 * ScenarioDecoder.h
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#ifndef __ScenarioDecoder_h__
#define __ScenarioDecoder_h__
/**********************************************************************
	Scenario decoder class
	
**********************************************************************/
#include "ScenarioDecoderSystem.h"
//
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD {
#endif
	class CScenarioDecoder;
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif
//
// class
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
class ALSD::CScenarioDecoder {
#else
class CScenarioDecoder {
#endif
public:
	CScenarioDecoder( const char *_lpFileList );
	virtual ~CScenarioDecoder();
	
	CScenarioParser *GetParser		( void )const { return m_lpParser;};
	CFileCtrl		*GetFileCtrl	( void )const { return m_lpFileCtrl;};
	CSelectionCtrl	*GetSelCtrl		( void )const { return m_lpSelCtrl;};
	CMessageCtrl	*GetMsgCtrl		( void )const { return m_lpMsgCtrl;};
	CCommandDriver	*GetCmdDriver	( void )const { return m_lpCmdDriver;};
	CExpressionDriver *GetExpDriver	( void )const { return m_lpExpDriver;};
	CGraphicDriver	*GetGrpDriver	( void )const { return m_lpGrpDriver;};
	CCDPlayer		*GetCDPlayer	( void )const { return m_lpCDPlayer;};

	//
	long Run( void );
	void SetScenarioVersion( long _ver ){ m_ScenarioVersion = _ver;};
	
	bool m_bExit;

protected:
	//
	long m_ScenarioVersion;
	// file controller and drivers
	CFileCtrl			*m_lpFileCtrl;
	CSelectionCtrl		*m_lpSelCtrl;
	CMessageCtrl		*m_lpMsgCtrl;
	CScenarioParser		*m_lpParser;	// (: CScenarioDriver)
	CCommandDriver		*m_lpCmdDriver;
	CExpressionDriver	*m_lpExpDriver;
	CGraphicDriver		*m_lpGrpDriver;
	CCDPlayer			*m_lpCDPlayer;
private:
};

#endif
