/*
 * ScenarioDecoderSystem.cpp
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "ScenarioDecoderSystem.h"

#ifndef NDEBUG
#ifndef _DEBUG
#define _DEBUG
#endif
#endif

#if _MSC_VER > 1000
#define STRICT 1
#include <windows.h>
#endif

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
namespace ALSD {
#endif
	int TRACE( FILE *fp, const char *_Format ... );
#ifdef _DEBUG
	int TRACE( const char *_Format ... ); // output stderr
#else
	int TRACE( const char *_Format ... ){ return 0;};
#endif
	int stricmp( const char *string1, const char *string2 );
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
};
#endif

/**********************************************************************
	for Debug 
**********************************************************************/
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
int ALSD::TRACE( FILE *fp, const char *_Format ... )
#else
int TRACE( FILE *fp, const char *_Format ... )
#endif
{
#ifdef _DEBUG
	va_list vl;
	va_start( vl, _Format );
	int ret = vfprintf( fp, _Format, vl );
	va_end(vl);
	
	return ret;
#else
	return 0;
#endif
}

#ifdef _DEBUG
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
int ALSD::TRACE( const char *_Format ... )
#else
int TRACE( const char *_Format ... )
#endif
{
	va_list vl;
	va_start( vl, _Format );
#if _MSC_VER > 1000
	// WIN32
	char work[1024];
	int ret = _vsnprintf(work, 1024, _Format, vl);
	::OutputDebugString( work );
#else
//	int ret = vfprintf( stderr, _Format, vl );
	int ret = vfprintf( stdout, _Format, vl );
#endif
	va_end(vl);

	return ret;
}
#endif

/**********************************************************************
	stricmp
**********************************************************************/
#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
int ALSD::stricmp( const char *string1, const char *string2 )
#else
int stricmp( const char *string1, const char *string2 )
#endif
{
	while( *string1 != '\0' && *string2 != '\0' ){
		if( toupper(*string1) != toupper(*string2)){
			if( toupper(*string1) < toupper(*string2)){
				return -1;
			}else{
				return 1;
			}
		}
		string1++;
		string2++;
	}
	return 0;
}


