/*
 * ScenarioDriver.cpp - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 *      99/05/24 KISAKA Toshihiro       modify for mwcc compatiblility
 *
 */

#include "stdafx.h"
#include "ScenarioDriver.h"

#include "ScenarioDecoder.h"
#include "EALSD.h"
#include "FileCtrl.h"
#include "FileData.h"

#if (!__MWERKS__ || defined(MSIPL_USING_NAMESPACE))
using namespace ALSD;
using namespace ALSD_SDRV;
using namespace endian;
using namespace std;
#endif
/**********************************************************************
	RXgNV
**********************************************************************/
CScenarioDriver::CScenarioDriver( CScenarioDecoder *_lpScenarioDecoder )
{
	m_lpStack	= m_lpStackBuff;
	m_Page		= 0;
	m_Address	= 0;
//	m_lpFileData= new CFileData;
	m_lpSD		= _lpScenarioDecoder;

	FarJamp(0);
}

CScenarioDriver::~CScenarioDriver()
{
//	if( m_lpFileData )delete[] m_lpFileData;
}
#if 0
/**********************************************************************
	X^bN
**********************************************************************/
void CScenarioDriver::_Push( long _Type, long *_lpMem, long _Size )
{
	// 
	_lpMem += (_Size - 1 );
	for( int i = 0; i < _Size; i++){
		m_Stack.push( *_lpMem-- ); // 
	}
	m_Stack.push( _Size );
	m_Stack.push( _Type );
}

void CScenarioDriver::_Pop( long *_lpType, long **_lplpMem, long *_lpSize )
{
	long *lpMem;
	
	*_lpType = m_Stack.top();m_Stack.pop();
	*_lpSize = m_Stack.top();m_Stack.pop();
	
	lpMem = new long[*_lpSize];
	for( int i = 0; i < *_lpSize; i++){
		lpMem[i] = m_Stack.top();m_Stack.pop();	
	}
	*_lplpMem = lpMem;
}
#else
/**********************************************************************
	X^bN
**********************************************************************/
void CScenarioDriver::_Push( long _Type, long *_lpMem, long _Size )
{
	// 
	_lpMem += (_Size - 1 );
	for( int i = 0; i < _Size; i++){
		*m_lpStack = *_lpMem--;
		m_lpStack++;
	}
	*m_lpStack = _Size; m_lpStack++;
	*m_lpStack = _Type; m_lpStack++;
}

void CScenarioDriver::_Pop( long *_lpType, long **_lplpMem, long *_lpSize )
{
	long *lpMem;
	
	*_lpType = *--m_lpStack;
	*_lpSize = *--m_lpStack;
	
	lpMem = new long[*_lpSize];
	for( int i = 0; i < *_lpSize; i++){
		lpMem[i] = *--m_lpStack;
	}
	*_lplpMem = lpMem;
}
#endif
/**********************************************************************
	UG/US
**********************************************************************/
void CScenarioDriver::PushVar( const long *_lpMem, long _Count )
{
	long *lpTmp = new long[_Count + 2];
	
	lpTmp[0]	= m_lpSD->GetExpDriver()->GetPrevVarPage();
	lpTmp[1]	= m_lpSD->GetExpDriver()->GetPrevVarIndex();
	memcpy(&lpTmp[2], _lpMem, sizeof(long) * _Count );
	_Push( SDRV_STACKTYPE_VARIABLE, lpTmp, _Count + 2 );
	
	delete[] lpTmp;
}
void CScenarioDriver::PopVar (       long *_lpMem, long _Count )
{
	long  Type;
	long *lpTmp;
	long  Count;
	
	_Pop( &Type, &lpTmp, &Count );

	memcpy(_lpMem, lpTmp + 2, sizeof(long) * _Count - 2);
	
	delete[] lpTmp;
}


/**********************************************************************
	y[WWv
**********************************************************************/
void CScenarioDriver::NearJamp( long _Address )
{
	m_Address = _Address;
}

void CScenarioDriver::NearCall( long _Address )
{
	// X^bN֐ς
	_Push( SDRV_STACKTYPE_NEARJAMP, &m_Address, 1 );
	// Wv
	m_Address = _Address;
}

void CScenarioDriver::NearRet( void )
{
	long Type, Size;
	long *lpStack = NULL;
	_Pop( &Type, &lpStack, &Size );

	//
	while( Type != SDRV_STACKTYPE_NEARJAMP ){
		// UŜ͎Ă
		if( Type == SDRV_STACKTYPE_VARIABLE ){
			delete[] lpStack;
			_Pop( &Type, &lpStack, &Size );
		}else{
			throw EALSD_Msg("error:illigal call stack( near ret )\n");
		}
	}
	
	//
	long Address = *lpStack;
	if( lpStack )delete[] lpStack;
	
	NearJamp( Address );
}

/**********************************************************************
	y[WOWv
**********************************************************************/
void CScenarioDriver::FarJamp( long _Page )
{
	// ViIt@C擾
//	m_lpSD->GetFileCtrl()->LoadData( m_lpFileData, DATATYPE_SCO, _Page );
	m_lpSD->GetFileCtrl()->LoadData( &m_lpFileData, DATATYPE_SCO, _Page );
	m_lpMem = (unsigned char *)m_lpFileData->GetData();
	m_Page	= _Page;
	m_Address = GetLE_DW( m_lpMem + 4 );
}

void CScenarioDriver::FarJamp( long _Page, long _Address )
{
	// ViIt@C擾
//	m_lpSD->GetFileCtrl()->LoadData( m_lpFileData, DATATYPE_SCO, _Page );
	m_lpSD->GetFileCtrl()->LoadData( &m_lpFileData, DATATYPE_SCO, _Page );
	m_lpMem = (unsigned char *)m_lpFileData->GetData();
	m_Page	= _Page;
	m_Address = _Address;
}

void CScenarioDriver::FarCall( long _Page )
{
	// X^bNɐς
	long mem[2];
	mem[0] = m_Page;
	mem[1] = m_Address;
	_Push( SDRV_STACKTYPE_FARJAMP, mem, 2 );

	FarJamp( _Page );
}

void CScenarioDriver::FarCall( long _Page, long _Address )
{
	// X^bNɐς
	long mem[2];
	mem[0] = m_Page;
	mem[1] = m_Address;
	_Push( SDRV_STACKTYPE_FARJAMP, mem, 2 );

	FarJamp( _Page, _Address );
}

void CScenarioDriver::FarRet( void )
{
	long Type, Size;
	long *lpStack = NULL;
	_Pop( &Type, &lpStack, &Size );

	//
	while( Type != SDRV_STACKTYPE_FARJAMP ){
		// UŜ͎Ă
		if( Type == SDRV_STACKTYPE_VARIABLE ){
			delete[] lpStack;
			_Pop( &Type, &lpStack, &Size );
		} if (Type == SDRV_STACKTYPE_NEARJAMP ){
			throw EALSD_Msg("error:illigal call stack( (near jamp) in (far ret) )\n");
		}else{
			throw EALSD_Msg("error:illigal call stack( far ret )\n");
		}
	}

	//
	long Page	= lpStack[0];
	long Address= lpStack[1];
	
	if( lpStack )delete[] lpStack;
	
	FarJamp( Page, Address );
}

/**********************************************************************
	[h^_u[h擾
**********************************************************************/
long CScenarioDriver::GetW( void )
{
	long ret = GetLE_WD( &m_lpMem[m_Address]);
	m_Address += 2;
	return ret;
}

long CScenarioDriver::GetRW( void ) const
{
	return GetLE_WD( &m_lpMem[m_Address]);
}

long CScenarioDriver::GetRW( long _Address ) const
{
	return GetLE_WD( &m_lpMem[_Address]);
}


long CScenarioDriver::GetDW( void )
{
	long ret = GetLE_DW( &m_lpMem[m_Address] );
	m_Address += 4;
	return ret;
}

/**********************************************************************
	X^bÑZ[u	
**********************************************************************/
size_t CScenarioDriver::SaveStack( FILE *fp )
{
	// TCY{\̈
	long Header[4];
	memset( Header, 0, sizeof(Header) );
	Header[0]= (m_lpStack - m_lpStackBuff) * sizeof(long);
	fwrite( Header, sizeof(long), 4, fp );

	// X^bN
	if( Header[0] ){
		fwrite( m_lpStackBuff, Header[0], 1, fp );
	}

	return sizeof(long) * 4 + Header[0];
}

/**********************************************************************
	X^bN[h
**********************************************************************/
size_t CScenarioDriver::LoadStack( FILE *fp )
{
	// wb_ǂݍ
	long Header[4];
	fread( Header, sizeof(long), 4, fp );

	// X^bNɏ
	if( Header[0] ){
		fread( m_lpStackBuff, Header[0], 1, fp );
		m_lpStack = m_lpStackBuff + ( Header[0] / sizeof(long) );
	}

	return sizeof(long) * 4 + Header[0];
}

